Scriptname SLAdventures_CityTaxScript extends Quest 

Event OnInit()

	fLastCheck = new Float[10]
	fTimeSpent = new Float[10]
	fLastBounty = new Float[10]
	fLastBounty[0] = -1.0
	fLastBounty[1] = -1.0
	fLastBounty[2] = -1.0
	fLastBounty[3] = -1.0
	fLastBounty[4] = -1.0
	fLastBounty[5] = -1.0
	fLastBounty[6] = -1.0
	fLastBounty[7] = -1.0
	fLastBounty[8] = -1.0
	fLastBounty[9] = -1.0
	iBounty = new Int[10]
	iBounty[0] = 100
	iBounty[1] = 100
	iBounty[2] = 50
	iBounty[3] = 50
	iBounty[4] = 100
	iBounty[5] = 50
	iBounty[6] = 50
	iBounty[7] = 100
	iBounty[8] = 100
	iBounty[9] = 50
	
EndEvent 
	
Event OnUpdateGameTime()

	Int index = SLAdventures_ValidHoldCapitals.GetSize()
	While (index > 0)
		index -= 1
		If (Game.GetPlayer().IsInLocation(SLAdventures_ValidHoldCapitals.GetAt(index) as Location) == True)
			If (bThanesDontPay == True) && (SLA_Utility.IsThane(index) == True)
				return 
			EndIf
			If (fLastCheck[index] != 0.00)
				fTimeSpent[index] = fTimeSpent[index] + SLA_Utility.GetHoursPassed(fLastCheck[index])
			Else
				fTimeSpent[index] = 0.50
			EndIf
			fLastCheck[index] = Utility.GetCurrentGameTime()
			If (fTimeSpent[index] >= 8.00) && (Utility.GetCurrentGameTime() - fLastBounty[index] >= 1.00)
				(SLAdventures_ValidCrimeFactions.GetAt(index) as Faction).ModCrimeGold(iBounty[index])
				Debug.Notification(iBounty[index] + " Tax added to " + (SLAdventures_ValidCrimeFactions.GetAt(index) as Faction).GetName())
				fLastBounty[index] = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Utility.GetCurrentGameTime() - fLastCheck[index] >= 1.00)
			fTimeSpent[index] = 0.00
			fLastCheck[index] = 0.00
		EndIf
	EndWhile 
	
	RegisterForSingleUpdateGameTime(1)
	
EndEvent 

;Variables and Properties
;Variables
Float[] fLastCheck 
Float[] fTimeSpent
Float[] fLastBounty


;Properties
Bool Property bThanesDontPay Auto 
SLAdventures_Utility Property SLA_Utility Auto 


FormList Property SLAdventures_ValidHoldCapitals Auto
FormList Property SLAdventures_ValidCrimeFactions Auto 
Int[] Property iBounty Auto 

