Scriptname SLAdventures_DDiLoaderScript extends Quest 
;Script to handle DDi compatibility without adding a dependency

Event OnInit()

	;debug.notification("Trying to load DDiLibs!")
	RegisterForModEvent("SLAdv_DDiSuspend", "OnDDiSuspend")
	RegisterForModEvent("SLAdv_DDiResume", "OnDDiResume")
	DDILibs = Game.GetFormFromFile(0xF624, "Devious Devices - Integration.esm") as Quest 
	;If (DDiLibs != none)
		;debug.notification("DDiLibs Loaded!")
	;EndIf
	
EndEvent 

Event OnDDiSuspend(string eventName, string strArg, float numArg, Form sender)

	If ((DDILibs as zadlibs) != none)
		(DDILibs as zadlibs).GlobalEventFlag = False
	EndIf
	
EndEvent 

Event OnDDiResume(string eventName, string strArg, float numArg, Form sender)

	If ((DDILibs as zadlibs) != none)
		(DDILibs as zadlibs).GlobalEventFlag = True	
	EndIf
	
EndEvent 

Quest Property DDiLibs Auto Hidden 