Scriptname SLAdventures_GangRapeController extends Quest  

Event OnUpdate()

	If (sPhase == "Gangbang")
		SLAdventures_RapeScanSpellJoinIn.Cast(Player)
		RegisterForSingleUpdate(fPollRate)
	EndIf

EndEvent

Bool Function GangRape(FormList Attackers, FormList Victims = none, Bool AllowPursuit = True, Bool AllowJoinIn = True, Bool AddFollowersToVictims = True)

	If (IsPossible() == "") && (Attackers != none) && (Attackers.GetSize() != 0) 
		sPhase = "Starting"
		If (MCM.bDebugRapeUpdateMessage == True)
			Debug.Notification("Rape enters starting phase.")
		EndIf
		Rapists = new Actor[25]
		Int index = 0
		Int index2 = 0
		Actor akActor = none
		
		While (index < Attackers.GetSize()) && (index < iRapeMaxNumberAttackers)
			akActor = Attackers.GetAt(index) as Actor
			If (IsValidAttacker(akActor) == True) 
				Rapists[index2] = akActor
				index2 += 1
			EndIf
			index += 1
		EndWhile 
		
		If (Rapists[0] == none) 
			FinishGangRape(False)
			return False
		EndIf
		
		index = 0
		While (Rapists[index] != none)	
			AttackerAliases[index].ForceRefTo(Rapists[index])
			Rapists[index].AddToFaction(SLAdventures_RapeActors)
			Rapists[index].EvaluatePackage()
		index += 1
		EndWhile
		
		iNumRapists = index
		
		SexTrackers[0].StorePosition()
		SexTrackers[0].bIsInGangRape = True
		SexTrackers[0].bIsGangRapeDone = False
		SexTrackers[0].bUseRestrainedAnimations = IsActorRestrained(Player)
		If ((bRapeConsensualAdaptive == True) && (Aroused.GetActorArousal(Player) >= MCM.iPlayerArousalThreshhold))
			SexTrackers[0].bIsConsent = True
		ElseIf ((bRapeConsensualAdaptive == False) && (Utility.RandomInt(1, 100) <= iRapeConsensualChance))
			SexTrackers[0].bIsConsent = True
		Else
			SexTrackers[0].bIsConsent = False
		EndIf
		
		index = 0
		akActor = none
		iNumVictims = 0
		If (Victims != none)
			While (index < Victims.GetSize()) && (iNumVictims < 9)
				akActor = Victims.GetAt(index) as Actor
				If (IsValidVictim(akActor) == True) 
					iNumVictims += 1
					SexTrackers[iNumVictims].Track(akActor)
					SexTrackers[iNumVictims].bIsInGangRape = True
					SexTrackers[iNumVictims].bIsGangRapeDone = False
					SexTrackers[iNumVictims].bUseRestrainedAnimations = IsActorRestrained(akActor)
					If ((bRapeConsensualAdaptive == True) && (Aroused.GetActorArousal(akActor) >= MCM.iPlayerArousalThreshhold))
						SexTrackers[iNumVictims].bIsConsent = True
					ElseIf ((bRapeConsensualAdaptive == False) && (Utility.RandomInt(1, 100) <= iRapeConsensualChance))
						SexTrackers[iNumVictims].bIsConsent = True
					Else
						SexTrackers[iNumVictims].bIsConsent = False
					EndIf
				EndIf
				index += 1
			EndWhile 
		EndIf
		
		If (AddFollowersToVictims == True) && (iNumVictims < 9)
			If (bRapeFemaleFollowers == True) || (bRapeMaleFollowers == True)
				Actor[] Followers = DLCModsComp.GetFollowers()
				index = 0
				Cell PlayerCell = Player.GetParentCell()
				While (index < Followers.Length) && (iNumVictims < 9)
					If (Followers[index] != none) \
					&& ((bRapeFemaleFollowers == True) && (Sexlab.GetGender(Followers[index]) == 1)) || ((bRapeMaleFollowers == True) && (Sexlab.GetGender(Followers[index]) == 0)) \
					&& ((PlayerCell == Followers[index].GetParentCell()) || (Player.GetDistance(Followers[index]) < 2048)) \
					&& (IsValidVictim(Followers[index]) == True)
						iNumVictims += 1
						SexTrackers[iNumVictims].Track(Followers[index])
						SexTrackers[iNumVictims].bIsInGangRape = True
						SexTrackers[iNumVictims].bIsGangRapeDone = False
						SexTrackers[iNumVictims].bUseRestrainedAnimations = IsActorRestrained(Followers[index])
						If ((bRapeConsensualAdaptive == True) && (Aroused.GetActorArousal(Followers[index]) >= MCM.iPlayerArousalThreshhold))
							SexTrackers[iNumVictims].bIsConsent = True
						ElseIf ((bRapeConsensualAdaptive == False) && (Utility.RandomInt(1, 100) <= iRapeConsensualChance))
							SexTrackers[iNumVictims].bIsConsent = True
						Else
							SexTrackers[iNumVictims].bIsConsent = False
						EndIf
					EndIf 
					index += 1
				EndWhile
			EndIf
		EndIf
		
		If (AllowPursuit == False) || (bRapeAllowEscape == False) || (PursuePlayer() == True) 
			sPhase = "Gangbang"
			If (MCM.bDebugRapeUpdateMessage == True)
				Debug.Notification("Rape enters gangbang phase.")
			EndIf
			ShowRapeMessage(Rapists[0], Rapists[1], SexTrackers[0].bIsConsent)
			fAIGreetingDistanceSetting = Game.GetGameSettingFloat("fAIMinGreetingDistance")
			Game.SetGameSettingFloat("fAIMinGreetingDistance", 0.0)
			If (AllowJoinIn == True)
				RegisterForSingleUpdate(fPollRate)
			EndIf
			SexTrackers[0].StripActor(sStripType, Rapists, iNumRapists, !bRapeDontRemoveQuestItems, bUseSexlabStripping)
			If (StartSexScene(SexTrackers[0]) == False)
				SexTrackers[0].bIsGangRapeDone = True
				SexTrackers[0].RegisterForSingleUpdate(5.0)
			EndIf
			index = 1
			While (index <= iNumVictims) 
				SexTrackers[index].StripActor(sStripType, Rapists, iNumRapists, !bRapeDontRemoveQuestItems, bUseSexlabStripping)
				If (StartSexScene(SexTrackers[index]) == False)
					SexTrackers[index].bIsGangRapeDone = True
					SexTrackers[index].RegisterForSingleUpdate(5.0)
				EndIf
			index += 1
			EndWhile
			
			;debug.messagebox("AbortGangRape == " + bAbortGangRape)
			
			While ((SexTrackers[0].bIsGangRapeDone == False) \ 
				|| (SexTrackers[1].bIsGangRapeDone == False) \ 
				|| (SexTrackers[2].bIsGangRapeDone == False) \ 
				|| (SexTrackers[3].bIsGangRapeDone == False) \ 
				|| (SexTrackers[4].bIsGangRapeDone == False) \ 
				|| (SexTrackers[5].bIsGangRapeDone == False) \ 
				|| (SexTrackers[6].bIsGangRapeDone == False) \ 
				|| (SexTrackers[7].bIsGangRapeDone == False) \ 
				|| (SexTrackers[8].bIsGangRapeDone == False) \ 
				|| (SexTrackers[9].bIsGangRapeDone == False)) \ 
				&& (bAbortGangRape == False)
				Utility.Wait(2.0)
				;debug.messagebox("Waiting 2 seconds in GangRape()")
			EndWhile
			
			If (bAbortGangRape == False)
				FinishGangRape(True)
				return True
			Else
				FinishGangRape(False)
				return True
			EndIf
		Else 
			FinishGangRape(False)
			return False
		EndIf
	Else 
		return False
	EndIf
	
EndFunction

Bool Function PursuePlayer() 

	sPhase = "Pursuit"
	If (MCM.bDebugRapeUpdateMessage == True)
		Debug.Notification("Rape enters pursuit phase.")
	EndIf
	If (sAutoSurrender == "Always") || ((sAutoSurrender == "If Aroused") && (Aroused.GetActorArousal(Player) >= MCM.iPlayerArousalThreshhold))
		SexTrackers[0].bIsConsent = True
		;TODO set the rest of the victims
		return True
	EndIf
	Game.EnableFastTravel(False)
	;debug.notification("PursuePlayer()")
	Int index
	
	Float Timer = iRapeEscapeSeconds as float
	Timer += (Utility.RandomInt(1, 15) * 2) as float 
	;Real Escape Timer is random and up to 30 seconds longer than set in the MCM
	
	If (bRapeEscapeShowMessage == True)
		SexTrackers[0].bIsConsent = True
		Debug.Notification("Someone is following you...")
	EndIf
	
	While (Timer > 0)
		;debug.notification("Checking if player was caught")
	
		If (bPlayerSubmittedToRapeDuringPursuit == True)
			return True
		Else
			index = iNumRapists
			While (index > 0)
				index -= 1
				;debug.notification("Distance: " + Player.GetDistance(Rapists[index]))
				If (Player.GetDistance(Rapists[index]) <= 250) && (Rapists[index].IsDead() == False) && (Player.IsSwimming() == False)
					;Player was caught!
					;debug.notification("player was caught")
					If (bRapeEscapeShowMessage == True)
						If (Rapists[index].GetActorbase().IsUnique() == True)
							Debug.Notification(Rapists[index].GetDisplayName() + " caught you!")
						Else
							Debug.Notification("A " + Rapists[index].GetDisplayName() + " caught you!")
						EndIf	
					EndIf
					return True
				EndIf
			EndWhile
		EndIf
	Utility.Wait(2.0)
	Timer -= 2.0
	EndWhile 
	
	If (bRapeEscapeShowMessage == True)
		Debug.Notification("You have escaped!")
	EndIf
	return False
	;Player escaped!

EndFunction 

Function ShowRapeMessage(Actor akPrime, Actor akSecond, Bool Consent)

	String sType
	Bool PrimeUnique = akPrime.GetActorBase().IsUnique()
	If (Consent == True)
		sType = "to use you."
	Else
		sType = "to rape you!"
	EndIf

	If (iNumRapists == 1)
		If (PrimeUnique == True)
			Debug.Notification(akPrime.GetDisplayName() + " is going " + sType)
		Else
			Debug.Notification("A " + akPrime.GetDisplayName() + " is going " + sType)
		EndIf
	ElseIf (iNumRapists == 2)
		Bool SecondUnique = akSecond.GetActorBase().IsUnique()
		If (PrimeUnique == True) && (SecondUnique == True)
			Debug.Notification(akPrime.GetDisplayName() + " and " + akSecond.GetDisplayName() +" are going " + sType)
		ElseIf (PrimeUnique == True) && (SecondUnique == False)
			Debug.Notification(akPrime.GetDisplayName() + " and a " + akSecond.GetDisplayName() +" are going " + sType)
		ElseIf (PrimeUnique == False) && (SecondUnique == True)
			Debug.Notification("A " + akPrime.GetDisplayName() + " and " + akSecond.GetDisplayName() +" are going " + sType)
		Else ;both false
			Debug.Notification("A " + akPrime.GetDisplayName() + " and a " + akSecond.GetDisplayName() +" are going " + sType)
		EndIf
	Else ;at least 3 rapists
		If (Consent == True)
			Debug.Notification("You are going to be used.")
		Else
			Debug.Notification("You are going to be gangraped!")
		EndIf
	EndIf		
	
EndFunction 

Bool Function StartSexScene(SLAdventures_SexTracker VictimTracker) 

	Actor Victim = VictimTracker.GetTrackedActor()
	;debug.messagebox("StartSexScene() with Victim " + Victim.GetActorBase().GetName())
	If (Victim == Player)
		DisableControls()
	EndIf
	Actor[] SexlabActors
	Bool Restrained = VictimTracker.bUseRestrainedAnimations
	;debug.messagebox("Restrained: " + Restrained)
	If (Restrained == False) && (Utility.RandomInt(1,100) <= iRapeThreesomeChance)
		Actor Attacker = PickAttacker(Restrained)
		If (Attacker != none) 
			If (DoesActorAllowThreesome(Attacker) == True)
				Actor Attacker2 = PickAttacker(Restrained)
				If (Attacker2 != none) && (DoesActorAllowThreesome(Attacker2) == True)
					SexlabActors = new Actor[3]
					SexlabActors[0] = Victim
					SexlabActors[1] = Attacker
					SexlabActors[2] = Attacker2
				Else 
					SexlabActors = new Actor[2]
					SexlabActors[0] = Victim
					SexlabActors[1] = Attacker
				EndIf
			Else
				SexlabActors = new Actor[2]
				SexlabActors[0] = Victim
				SexlabActors[1] = Attacker
			EndIf
		Else
			return False
		EndIf
	Else
		Actor Attacker = PickAttacker(Restrained)
		If (Attacker != none)
			SexlabActors = new Actor[2]
			SexlabActors[0] = Victim
			SexlabActors[1] = Attacker
		Else 	
			return False
		EndIf
	EndIf
	
	Victim.Dismount()
	
	If (SexLabActors.Length == 3)
		SexlabActors[2].Dismount()
		If (SexlabActors[2].GetDistance(Player) > 250) 
			SexlabActors[2].MoveTo(Player)
		EndIf
	EndIf
	SexlabActors[1].Dismount()
	If (SexlabActors[1].GetDistance(Player) > 250) 
		SexlabActors[1].MoveTo(Player)
	EndIf
	
	If (bMaleVictimsInMalePosition == True) && (SexlabActors.Length > 1) && (Sexlab.GetGender(SexlabActors[0]) == 1)
		SexlabActors = SwitchMaleAndFemalePosition(SexlabActors)
	EndIf
	
	If (bDoNotRepositionVictimDuringGangRape == False) 
		VictimTracker.RestorePosition()
	EndIf
	
	If (VictimTracker.bUseRestrainedAnimations == True) 
		Int iEvent = ModEvent.Create("SLAdv_ZazRape")
		ModEvent.PushForm(iEvent, SexlabActors[0])
		ModEvent.PushForm(iEvent, SexlabActors[1])
		ModEvent.PushForm(iEvent, Victim)
		ModEvent.Send(iEvent)
	Else
		;debug.messagebox("Sexlab.StartSex()")
		Sexlab.StartSex(SexlabActors, GetValidAnimations(VictimTracker.bIsConsent, SexlabActors), Victim, Victim, False)
	EndIf
	;debug.messagebox("StartSexScene() returns True")
	return True

EndFunction

Function HandleEndOfSexScene(SLAdventures_SexTracker VictimTracker, Actor[] Partners, Bool OralScene, Bool VaginalScene, Bool AnalScene) 

	Int index = 0
	While (index < Partners.Length) 
		If (Partners[index] != VictimTracker.GetTrackedActor()) 
			Partners[index].SetFactionRank(SLAdventures_RapeActors, 2)
		EndIf
	index += 1
	EndWhile
	If (VictimTracker.GetTrackedActor() == Player) && (bRapeSpeedDebuffEnabled == True) && (VaginalScene == True || AnalScene == True) 
		;debug.notification("Adding Rape Speed Debuff")
		Player.AddSpell(SLAdventures_RapeSpeedDebuffSpell, False)
		SLAdventures_RapeSpeedDebuffStage.Mod(1)
	EndIf
	If (StartSexScene(VictimTracker) == False)
		VictimTracker.bIsGangRapeDone = True
	EndIf

EndFunction

Actor Function PickAttacker(Bool Restrained)

	Int index = 0
	Actor akActor = none
	While (index < iNumRapists) && (Rapists[index] != none) 
		If (Rapists[index].GetFactionRank(SLAdventures_RapeActors) < 1) 
			If (Restrained == False) || (Rapists[index].HasKeyword(ActorTypeNPC) == True) 
				akActor = Rapists[index]
				akActor.SetFactionRank(SLAdventures_RapeActors, 1)
				;debug.messagebox("PickAttacker returns an actor")
				return akActor
			EndIf
		EndIf
	index += 1
	EndWhile
	
	;debug.messagebox("PickAttacker() return none")
	return none

EndFunction

SLAdventures_SexTracker Function PickSecondaryVictim(Actor PrimaryVictim)

	Int index = 0
	Actor akActor = none
	While (index < iNumRapists) && (SexTrackers[index].GetTrackedActor() != none) 
		If (SexTrackers[index].bIsReserved == False) && (SexTrackers[index].GetTrackedActor() != PrimaryVictim) 
			akActor = SexTrackers[index].GetTrackedActor()
			SexTrackers[index].bIsReserved = True
			return SexTrackers[index]
		EndIf
	index += 1
	EndWhile
	
	return none

EndFunction

sslBaseAnimation[] Function GetValidAnimations(Bool Consensual, Actor[] Partners)

	String Tags
	String TagSuppress
	Int index = 0 
	Bool bRestrained = False
	Int iNumActors = Partners.Length
	
	;Determine which tags should be used, depending on gender, random chance and whether consensual animations should be used
	
	If (iNumActors == 2)
		If (Sexlab.GetGender(Partners[0]) == 1) && (Sexlab.GetGender(Partners[1]) == 1)
			Tags = "Lesbian"
		ElseIf (Sexlab.GetGender(Partners[0]) == 0) && (Sexlab.GetGender(Partners[1]) == 0)
			Tags = ""
		Else
			Tags = GetBaseAnimationTags()
			TagSuppress = "Lesbian"			
		EndIf
		If (Partners[1].HasKeyword(Vampire) == False)
			If (TagSuppress != "")
				TagSuppress += ",Feeding,Xandero"
			Else
				TagSuppress = "Feeding,Xandero"
			EndIf
		EndIf
	ElseIf (iNumActors == 3)
		If (Sexlab.GetGender(Partners[0]) == 1) && (Sexlab.GetGender(Partners[1]) == 1) && (Sexlab.GetGender(Partners[2]) == 1)
			Tags = "Lesbian"
		ElseIf (Sexlab.GetGender(Partners[0]) == 0) && (Sexlab.GetGender(Partners[1]) == 0) && (Sexlab.GetGender(Partners[2]) == 0)
			Tags = ""
		Else
			Tags = GetBaseAnimationTags() 
			If (Sexlab.GetGender(Partners[1]) == 1) || (Sexlab.GetGender(Partners[2]) == 1)
				TagSuppress = "FMM"
			Else
				TagSuppress = "FFM,Lesbian"
			EndIf
		EndIf
		If (Partners[1].HasKeyword(Vampire) == False) && (Partners[2].HasKeyword(Vampire) == False)
			If (TagSuppress != "")
				TagSuppress += ",Feeding,Xandero"
			Else
				TagSuppress = "Feeding,Xandero"
			EndIf
		EndIf
	EndIf
	
	If (Sexlab.GetGender(Partners[1]) < 2) && (iNumActors < 3) && (Tags != "Lesbian")
		;Creature or lesbian animations as well as Threesomes 
		;will not be tagged as consensual or aggressive
		;since we don't know what animations are installed
		
		If (Consensual == False)			
			Tags += ",Aggressive"
		Else
			TagSuppress = "Aggressive"
		EndIf
	EndIf
	
	;debug.notification("Tags: " + Tags)
	;debug.notification("TagSuppress: " + TagSuppress)
	;debug.notification("Sexlab.GetAnimationsByTags()")
	
	If (Tags == "") || (Tags == "Aggressive")
		;DD Assets is Loaded
		;Determine which holes are available based on worn Devious Devices.
		Bool bVaginalAvailable
		Bool bAnalAvailable
		Bool bOralAvailable
		If (Partners[0].WornHasKeyword(DLCModsComp.zad_DeviousBelt) == True)
			If (Partners[0].WornHasKeyword(DLCModsComp.zad_PermitVaginal) == True)
				bVaginalAvailable = True
			Else
				bVaginalAvailable = False
			EndIf
			If (Partners[0].WornHasKeyword(DLCModsComp.zad_PermitAnal) == True)
				bAnalAvailable = True
			Else
				bAnalAvailable = False
			EndIf
		Else
			bAnalAvailable = True
			bVaginalAvailable = True
		EndIf
		If (Partners[0].WornHasKeyword(DLCModsComp.zad_DeviousGag) == True) || (Partners[0].WornHasKeyword(DLCModsComp.zad_DeviousGagPanel) == True)
			If (Partners[0].WornHasKeyword(DLCModsComp.zad_PermitOral) == True)
				bOralAvailable = True
			Else
				bOralAvailable = False
			EndIf
		Else
			bOralAvailable = True
		EndIf
		
		Tags += GetBaseAnimationTags(bVaginalAvailable, bAnalAvailable, bOralAvailable)
		
		If (Sexlab.GetGender(Partners[1]) == 1) || (Sexlab.GetGender(Partners[2]) == 1)
			TagSuppress += ",FMM"
		Else
			TagSuppress += ",FFM,Lesbian"
		EndIf
	EndIf
	return SexLab.GetAnimationsByTags(iNumActors, Tags, TagSuppress, True)

EndFunction

String Function GetBaseAnimationTags(Bool AllowVaginal = True, Bool AllowAnal = True, Bool AllowOral = True) 

	;Determines whether the animation is Vaginal, Anal or Oral 
	String Tags = ""
	Int index 
	If (DLCModsComp.bDDAssetsIsLoaded == False)
		index = Utility.RandomInt(1, 3)
		If (index == 1)
			Tags = "Vaginal"
		ElseIf (index == 2)
			Tags = "Anal"
		Else
			Tags = "Oral"
		EndIf
	Else
		index = Utility.RandomInt(1, 3)
		If (index == 1)
			If (AllowVaginal == True) 
				Tags = "Vaginal"
			ElseIf (AllowAnal == True)
				Tags = "Anal"
			ElseIf (AllowOral == True)
				Tags = "Oral"
			EndIf
		ElseIf (index == 2)
			If (AllowAnal == True)
				Tags = "Anal"
			ElseIf (AllowOral == True)
				Tags = "Oral"
			ElseIf (AllowVaginal == True) 
				Tags = "Vaginal"
			EndIf
		Else
			If (AllowOral == True)
				Tags = "Oral"
			ElseIf (AllowVaginal == True) 
				Tags = "Vaginal"
			ElseIf (AllowAnal == True)
				Tags = "Anal"
			EndIf
		EndIf
	EndIf
	
	return Tags 
	
EndFunction

Actor[] Function SwitchMaleAndFemalePosition(Actor[] akActors)

	Actor akActor = akActors[0]
	akActors[0] = akActors[1]
	akActors[1] = akActor
	return akActors
	
EndFunction

Function FinishGangRape(Bool RapeWasSuccessful)

	sPhase = "Finishing"
	If (MCM.bDebugRapeUpdateMessage == True)
		Debug.Notification("Rape enters finishing phase.")
	EndIf
	UnregisterForUpdate()
	Game.EnableFastTravel(True)
	EnableControls()
	DetermineLastRapists(Rapists)
	bAbortGangRape = False
	bPlayerSubmittedToRapeDuringPursuit = False
	Game.SetGameSettingFloat("fAIMinGreetingDistance", fAIgreetingdistancesetting)
	
	SexTrackers[0].bIsInGangRape = False
	SexTrackers[0].bIsGangRapeDone = True
	SexTrackers[0].bUseRestrainedAnimations = False
	SexTrackers[0].bIsConsent = False
	
	While (iNumVictims > 0) 
		iNumVictims -= 1
		SexTrackers[iNumVictims].bIsInGangRape = False
		SexTrackers[iNumVictims].bIsGangRapeDone = True
		SexTrackers[iNumVictims].bUseRestrainedAnimations = False
		SexTrackers[iNumVictims].bIsConsent = False
		SexTrackers[iNumVictims].UnTrack()
	EndWhile
	
	Int index = 0
	While (Rapists[index] != none) && (index < 25)
		Rapists[index].RemoveFromFaction(SLAdventures_RapeActors)
		AttackerAliases[index].Clear()
		Rapists[index].EvaluatePackage()
		index += 1
	EndWhile
	
	ProximityRape.fLastRape = Utility.GetCurrentGameTime()
	iNumRapists = 0
	Rapists = new Actor[1]
	sPhase = "Idle"
	If (MCM.bDebugRapeUpdateMessage == True)
		Debug.Notification("Rape enters idle phase.")
	EndIf

EndFunction

Function AbortGangRape() 
	If (sPhase != "Idle") 
		bAbortGangRape = True
	Else 
		bAbortGangRape = False
	EndIf
EndFunction

String Function IsPossible()
	
	If (Sexlab.IsValidActor(Player) == False)
		return "PC is an invalid Sexlab target"
	EndIf 
	
	If (sPhase != "Idle")
		return "already in gang rape"
	EndIf
	
	If (Player.IsInCombat() == True)
		return "in combat"
	EndIf 
	
	If (Player.IsSwimming() == True)
		return "PC is swimming"
	EndIf
	
	;Mod Compatibility 
	
	If (SLA_Utility.bDDHelplessSuspend == True) && (bIgnoreDDHelplessSuspend == False)
		return "Deviously Helpless Suspend"
	Endif
	
	If ((StorageUtil.HasIntValue(Player, "xpoPCInJail") == True) && (StorageUtil.GetIntValue(Player, "xpoPCInJail") == 1)) \
	|| ((StorageUtil.HasIntValue(Player, "xpoPCArrested") == True) && (StorageUtil.GetIntValue(Player, "xpoPCArrested") == 1)) \
	|| ((StorageUtil.HasIntValue(Player, "xpoPCArrestStart") == True) && (StorageUtil.GetIntValue(Player, "xpoPCArrestStart") == 1))
		return "PC is imprisoned in POP"
	EndIf
	
	If (DLCModsComp.bDDAssetsIsLoaded == True) && (Player.WornHasKeyword(DLCModsComp.zad_DeviousBelt))
		If (Player.WornHasKeyword(DLCModsComp.zad_PermitAnal) == True) || (Player.WornHasKeyword(DLCModsComp.zad_PermitVaginal) == True)
			;Do nothing
		ElseIf (Player.WornHasKeyword(DLCModsComp.zad_DeviousGag) == True || (Player.WornHasKeyword(DLCModsComp.zad_DeviousGagPanel) == True)) && (Player.WornHasKeyword(DLCModsComp.zad_PermitOral) == True)
			;Do nothing
		ElseIf (Player.WornHasKeyword(DLCModsComp.zad_DeviousGag) == False) && (Player.WornHasKeyword(DLCModsComp.zad_DeviousGagPanel) == False)
			;Do nothing
		Else 
			return "PC is belted and no holes are free"
		EndIf 
	EndIf
	
	If (DLCModsComp.bDDAssetsIsLoaded == True) && (DLCModsComp.bZAPISLoaded == False) && ((Player.WornHasKeyword(DLCModsComp.zad_DeviousArmbinder)) || (Player.WornHasKeyword(DLCModsComp.zad_DeviousYoke)))
		return "PC is restrained, but ZaZ is missing"
	EndIf
	
	return ""

EndFunction

Bool Function IsIdle()
	return (sPhase == "Idle")
EndFunction 

String Function GetPhase()
	return sPhase
EndFunction

Bool Function IsValidAttacker(Actor akActor)

	If (akActor == none)
		return False
	EndIf
	
	If (akActor == Player) 
		return False
	EndIf

	If (SLA_Utility.IsSummonedActor(akActor) == True)
		return False
	EndIf
	
	If (akActor.IsDead() == True)
		return False
	EndIf
	
	If (akActor.IsDisabled() == True)
		return False
	EndIf
	
	If (akActor.IsHostileToActor(Player) == True)
		return False
	EndIf
	
	If (akActor.IsInCombat() == True)
		return False
	EndIf
	
	If (akActor.HasKeyword(ActorTypeAnimal) == True)
		If (IsActorRestrained(Player) == True)
			return False
		EndIf
	ElseIf (akActor.HasKeyword(ActorTypeCreature) == True)
		If (IsActorRestrained(Player) == True)
			return False
		EndIf	
	EndIf
	
	If (SexLab.IsValidActor(akActor) == False)
		return False
	EndIf
	
	return True
	
EndFunction 

Bool Function IsValidVictim(Actor akActor)

	If (akActor == none)
		return False
	EndIf
	
	If (akActor == Player) 
		return False
	EndIf

	If (SLA_Utility.IsSummonedActor(akActor) == True)
		return False
	EndIf
	
	If (akActor.IsDead() == True)
		return False
	EndIf
	
	If (Rapists.Find(akActor) != -1) 
		return False
	EndIf

	If (SexLab.IsValidActor(akActor) == False)
		return False
	EndIf
	
	If (akActor.IsHostileToActor(Player) == True)
		return False
	EndIf
	
	If (akActor.IsInCombat() == True)
		return False
	EndIf
	
	If (akActor.HasKeyword(ActorTypeNPC) != True)
		return False
	EndIf
	
	If (DLCModsComp.bDDAssetsIsLoaded == True) && (akActor.WornHasKeyword(DLCModsComp.zad_DeviousBelt))
		If (akActor.WornHasKeyword(DLCModsComp.zad_PermitAnal) == True) || (akActor.WornHasKeyword(DLCModsComp.zad_PermitVaginal) == True)
			;Do nothing
		ElseIf (akActor.WornHasKeyword(DLCModsComp.zad_DeviousGag) == True || (akActor.WornHasKeyword(DLCModsComp.zad_DeviousGagPanel) == True)) && (akActor.WornHasKeyword(DLCModsComp.zad_PermitOral) == True)
			;Do nothing
		ElseIf (akActor.WornHasKeyword(DLCModsComp.zad_DeviousGag) == False) && (akActor.WornHasKeyword(DLCModsComp.zad_DeviousGagPanel) == False)
			;Do nothing
		Else 
			return False
		EndIf 
	EndIf
	
	If (DLCModsComp.bDDAssetsIsLoaded == True) && (DLCModsComp.bZAPISLoaded == False) && ((akActor.WornHasKeyword(DLCModsComp.zad_DeviousArmbinder)) || (akActor.WornHasKeyword(DLCModsComp.zad_DeviousYoke)))
		return False
	EndIf
	
	return True
	
EndFunction 

Bool Function HasRestrainedActor(Actor[] akActors)
	;Bound animations need to go through ZAP (apparantly)
	;returns whether the array has a restrained actor
	
	Int index = 0
	
	If (DLCModsComp.bDDAssetsIsLoaded == True)
	
		While (index < akActors.Length)
			
			If ((akActors[index].WornHasKeyword(DLCModsComp.zad_DeviousArmbinder)) || (akActors[index].WornHasKeyword(DLCModsComp.zad_DeviousYoke)))
				;debug.notification(akActors[index].GetDisplayName() + " is restrained.")
				return True
			EndIf
			
		index += 1
		EndWhile
		return False	
	Else
		return False
	EndIf
		
EndFunction 

Bool Function IsActorRestrained(Actor akActor)

	If (DLCModsComp.bDDAssetsIsLoaded == True)
			
		If ((akActor.WornHasKeyword(DLCModsComp.zad_DeviousArmbinder)) || (akActor.WornHasKeyword(DLCModsComp.zad_DeviousYoke)))
			;debug.notification(akActor.GetDisplayName() + " is restrained.")
			return True
		EndIf

		return False	
	Else
		return False
	EndIf
	
EndFunction

Bool Function DoesActorAllowThreesome(Actor akActor)
	return (akActor.HasKeyword(ActorTypeNPC))
EndFunction 

Function HotKeySubmit()

	If (bPlayerSubmittedToRapeDuringPursuit == False)
		bPlayerSubmittedToRapeDuringPursuit = True
		Debug.Notification(GetSubmitMessage())
	EndIf

EndFunction 

String Function GetSubmitMessage()

	If (bRapeEscapeUseConsensualAnimationsOnSubmit == True)
		return "You surrender, like a good girl."
	EndIf
	
	Int index = Utility.RandomInt(1, 3)
	
	If (index == 1)
		return "You surrender."
	ElseIf (index == 2)
		return "You surrender to be raped."
	ElseIf (index == 3)
		return "You surrender to anything they want."
	EndIf
	
	return ""

EndFunction 

Function ActorJoinsGangRape(Actor akActor)

	If (sPhase == "Gangbang") && (Rapists.Find(akActor) < 0) && (akActor.IsInFaction(SLAdventures_GangRapeVictimFaction) == False) && (ProximityRape.IsValidAttacker(akActor)) 
		Int index = Rapists.Find(none)
		;debug.notification("Actor " + akActor.GetName() + "joins GangRape at index " + index)
		Rapists[index] = akActor
		AttackerAliases[index].ForceRefTo(Rapists[index])
		Rapists[index].AddToFaction(SLAdventures_RapeActors)
		Rapists[index].EvaluatePackage()
		iNumRapists += 1
	EndIf

EndFunction

Function DisableControls()
	Game.DisablePlayerControls( \
		abMovement = True, abFighting = True, abCamSwitch = False, abLooking = False, abSneaking = False, abMenu = False, abActivate = True, abJournalTabs = False)
EndFunction

Function EnableControls()
	Game.EnablePlayerControls(True, True, False, False, False, False, True, False)
EndFunction

Function DetermineLastRapists(Actor[] akActors)

	Int index = 0
	While (index < 25) && (akActors[index] != none)
		index += 1
	EndWhile
	
	If (index == 1)
		LastRapists = new Actor[1]
	ElseIf (index == 2)
		LastRapists = new Actor[2]
	ElseIf (index == 3)
		LastRapists = new Actor[3]
	ElseIf (index == 4)
		LastRapists = new Actor[4]
	ElseIf (index == 5)
		LastRapists = new Actor[5]
	ElseIf (index == 6)
		LastRapists = new Actor[6]
	ElseIf (index == 7)
		LastRapists = new Actor[7]
	ElseIf (index == 8)
		LastRapists = new Actor[8]
	ElseIf (index == 9)
		LastRapists = new Actor[9]
	ElseIf (index == 10)
		LastRapists = new Actor[10]
	ElseIf (index == 11)
		LastRapists = new Actor[11]
	ElseIf (index == 12)
		LastRapists = new Actor[12]
	ElseIf (index == 13)
		LastRapists = new Actor[13]
	ElseIf (index == 14)
		LastRapists = new Actor[14]
	ElseIf (index == 15)
		LastRapists = new Actor[15]
	ElseIf (index == 16)
		LastRapists = new Actor[16]
	ElseIf (index == 17)
		LastRapists = new Actor[17]
	ElseIf (index == 18)
		LastRapists = new Actor[18]
	ElseIf (index == 19)
		LastRapists = new Actor[19]
	ElseIf (index == 20)
		LastRapists = new Actor[20]
	ElseIf (index == 21)
		LastRapists = new Actor[21]
	ElseIf (index == 22)
		LastRapists = new Actor[22]
	ElseIf (index == 23)
		LastRapists = new Actor[23]
	ElseIf (index == 24)
		LastRapists = new Actor[24]
	ElseIf (index == 25)
		LastRapists = new Actor[25]
	EndIf
	
	index = 0
	While (index < 25) && (akActors[index] != none)
		LastRapists[index] = akActors[index]
		index += 1
	EndWhile

EndFunction

Actor[] Function GetLastRapists()
	return LastRapists
EndFunction

SLAdventures_GangRapeController Function GetInstance() Global
	return Game.GetFormFromFile(0xA4B5, "SLAdventures.esp") as SLAdventures_GangRapeController
EndFunction

Function SaveMCMOptions(String FileName) 

	SLAdventures_MCM_StorageScript.StoreStringValue(FileName, "RapeStripType", sStripType)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeMaxNumberOfAttackers", iRapeMaxNumberAttackers)
	
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeThreesomeChance", iRapeThreesomeChance)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeConsensualAdaptive", bRapeConsensualAdaptive)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeConsensualChance", iRapeConsensualChance)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeDontRemoveQuestItems", bRapeDontRemoveQuestItems)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeAllowEscape", bRapeAllowEscape)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "RapeEscapeSeconds", iRapeEscapeSeconds)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeEscapeShowMessage", bRapeEscapeShowMessage)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeEscapeUseConsensualAnimationsOnSubmit", bRapeEscapeUseConsensualAnimationsOnSubmit)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeAllowActorsToJoin", bRapeAllowActorsToJoin)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeSpeedDebuffEnabled", bRapeSpeedDebuffEnabled)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapePlayerInMalePosition", bMaleVictimsInMalePosition)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeDoNotRepositionVictimDuringGangRape", bDoNotRepositionVictimDuringGangRape)
	
	SLAdventures_MCM_StorageScript.StoreStringValue(FileName, "RapeAutoSurrender", sAutoSurrender)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeIgnoreDDHelplessSuspend", bIgnoreDDHelplessSuspend)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeControllerUseSexlabStripping", bUseSexlabStripping)

	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeControllerRapeFemaleFollowers", bRapeFemaleFollowers)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "RapeControllerRapeMaleFollowers", bRapeMaleFollowers)

EndFunction 

Function LoadMCMOptions(String FileName) 

	String[] StripTypes = new String[4]
	StripTypes[0] = "Strip"
	StripTypes[1] = "Drop"
	StripTypes[2] = "Steal"
	StripTypes[3] = "Destroy"
	sStripType = SLAdventures_MCM_StorageScript.LoadStringValue(FileName, "RapeStripType", StripTypes)
	iRapeMaxNumberAttackers = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeMaxNumberOfAttackers", 1, 25)
	String[] AttackerGenders = new String[3]
	AttackerGenders[0] = "Male"
	AttackerGenders[1] = "Female"
	AttackerGenders[2] = "Either"
	
	iRapeThreesomeChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeThreesomeChance", 0, 100)
	bRapeConsensualAdaptive = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeConsensualAdaptive")
	iRapeConsensualChance = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeConsensualChance", 0, 100)
	bRapeDontRemoveQuestItems = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeDontRemoveQuestItems")
	
	bRapeAllowEscape = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeAllowEscape")
	iRapeEscapeSeconds = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "RapeEscapeSeconds", 30, 120)
	bRapeEscapeShowMessage = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeEscapeShowMessage")
	bRapeEscapeUseConsensualAnimationsOnSubmit = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeEscapeUseConsensualAnimationsOnSubmit")
	bRapeAllowActorsToJoin = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeAllowActorsToJoin")
	bRapeSpeedDebuffEnabled = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeSpeedDebuffEnabled")
	bMaleVictimsInMalePosition = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapePlayerInMalePosition")
	bDoNotRepositionVictimDuringGangRape = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeDoNotRepositionVictimDuringGangRape")
	
	String[] AutoSurrenders = new String[3]
	AutoSurrenders[0] = "Disabled"
	AutoSurrenders[1] = "Always"
	AutoSurrenders[2] = "If Aroused"
	sAutoSurrender = SLAdventures_MCM_StorageScript.LoadStringValue(FileName, "RapeAutoSurrender", AutoSurrenders)
	bIgnoreDDHelplessSuspend = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeIgnoreDDHelplessSuspend")
	
	bUseSexlabStripping = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeControllerUseSexlabStripping")
	
	bRapeFemaleFollowers = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeControllerRapeFemaleFollowers")
	bRapeMaleFollowers = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "RapeControllerRapeMaleFollowers")

EndFunction 

;Variables and Properties - no functions after this line 

;Variables 

Actor[] Rapists
Actor[] LastRapists
Float fAIgreetingdistancesetting
String sPhase = "Idle"
Int iNumVictims = 0
Int iNumRapists = 0
Bool bAbortGangRape = False
Bool bPlayerSubmittedToRapeDuringPursuit = False
 
;Properties 
Actor Property Player Auto
ReferenceAlias[] Property AttackerAliases Auto

SLAdventures_SexTracker[] Property SexTrackers Auto 
SLAdventures_MCM_Script Property MCM Auto 
SexLabFramework Property Sexlab Auto 
SLAdventures_CrimeScript Property Crime Auto 
SLAdventures_Utility Property SLA_Utility Auto 
slaframeworkscr Property Aroused Auto 
SLAdventures_DLCAndModCompScript Property DLCModsComp Auto 
SLAdventures_SexDiary Property SexDia Auto 
SLAdventures_SleepCreepScript Property SleepCreep Auto  
SLAdventures_PlayerSexTracker Property PlayerSexTracker Auto 
SLAdventures_ProximityRapeScript Property ProximityRape Auto 

GlobalVariable Property SLAdventures_RapeSpeedDebuffStage Auto 
ImageSpaceModifier Property FadeToBlackIMod Auto 
ImageSpaceModifier Property FadeToBlackHoldIMod Auto 
ImageSpaceModifier Property FadeToBlackBackImod Auto 
Keyword Property ActorTypeCreature Auto 
Keyword Property ActorTypeAnimal Auto 
Keyword Property ActorTypeNPC Auto 
Keyword Property IsBeastRace Auto 
Race Property ElderRace Auto 
Faction Property SLAdventures_RapeActors Auto 
Keyword Property Vampire Auto 
Spell Property SLAdventures_RapeScanSpellJoinIn Auto 
Spell Property SLAdventures_RapeSpeedDebuffSpell Auto 
Faction Property SLAdventures_GangRapeVictimFaction Auto 
 
Float Property fPollRate = 20.0 Auto Hidden 
Bool Property bRapeAllowEscape = True Auto Hidden 
Int Property iRapeEscapeSeconds = 60 Auto Hidden 
Bool Property bRapeEscapeShowMessage = False Auto Hidden
Bool Property bRapeEscapeUseConsensualAnimationsOnSubmit = True Auto Hidden 
Bool Property bRapeAllowActorsToJoin = True Auto Hidden
Bool Property bRapeSpeedDebuffEnabled = True Auto Hidden 
Bool Property bMaleVictimsInMalePosition = False Auto Hidden 
Bool Property bDoNotRepositionVictimDuringGangRape = False Auto Hidden 
String Property sAutoSurrender = "Disabled" Auto Hidden 
Bool Property bRapeConsensualAdaptive = False Auto Hidden
Int Property iRapeConsensualChance = 50 Auto Hidden
Bool Property bRapeDontRemoveQuestItems = True Auto Hidden

String Property sStripType = "Strip" Auto Hidden
Int Property iRapeMaxNumberAttackers = 5 Auto Hidden

Bool Property bIgnoreDDHelplessSuspend = False Auto Hidden 
Int Property iRapeThreesomeChance = 50 Auto Hidden

Bool Property bUseSexlabStripping = False Auto Hidden 

Bool Property bRapeFemaleFollowers = True Auto Hidden 
Bool Property bRapeMaleFollowers = False Auto Hidden 
