Scriptname SLAdventures_PlayerLocationScanner extends ReferenceAlias  

Event OnLocationChange(Location akOldLoc, Location akNewLoc) 

	;debug.notification("Player.OnLocationChange()")
	;debug.notification("From " + akOldLoc.GetName() + " to " + akNewLoc.GetName())
	;debug.notification("Holds: " + FindHoldByLocation(akOldLoc).GetName() + ", " +FindHoldByLocation(akNewLoc).GetName())
	If (bShowCrimeLawsChange == True) && (Player.IsInInterior() == False)
		If (akOldLoc != none) 
			If (akNewLoc != none)
				OnHoldChange(FindHoldByLocation(akOldLoc), FindHoldByLocation(akNewLoc))
			Else
				OnHoldChange(FindHoldByLocation(akOldLoc), none)
			EndIf
		Else
			If (akNewLoc != none)
				OnHoldChange(none, FindHoldByLocation(akNewLoc))
			Else
				OnHoldChange(none, none)
			EndIf
		EndIf
	EndIf

EndEvent 

Function OnHoldChange(Location akOldHold, Location akNewHold)

	If (akOldHold != akNewHold) 
		If (akNewHold != none)
			Debug.Notification("This location is subject to " + akNewHold.GetName() + "'s laws.")
		Else 
			Debug.Notification("This location is lawless wilderness.")
		EndIf
	ElseIf (akNewHold == none)
		Debug.Notification("This location is lawless wilderness.")
	EndIf

EndFunction 

Location Function FindHoldByLocation(Location akLocation)

	Int index = 0
	While (index <= 9) 
		If ((SLAdventures_HoldsList.GetAt(index)) as Location).IsChild(akLocation)
			return (SLAdventures_HoldsList.GetAt(index) as Location)
		EndIf
		index += 1
	EndWhile
	return none

EndFunction

Actor Property Player Auto
FormList Property SLAdventures_HoldsList Auto  
SLAdventures_Utility Property SLA_Utility Auto 
Bool Property bShowCrimeLawsChange = False Auto Hidden 