Scriptname SLAdventures_SexDiary extends Quest 

Function Active()
	;Fill arrays
	
	iSexCrimeReports = new Int[6]
	iBeastPartners = new Int[21]
	
	BeastNames = new string[21]
	BeastNames[0] = "Dogs"
	BeastNames[1] = "Horses"
	BeastNames[2] = "Wolves"
	BeastNames[3] = "Bears"
	BeastNames[4] = "Deers"
	BeastNames[5] = "Cows"
	BeastNames[6] = "Goat"
	BeastNames[7] = "Skeevers"
	BeastNames[8] = "Falmers"
	BeastNames[9] = "Spiders"
	BeastNames[10] = "Chauruses"
	BeastNames[11] = "Werewolves"
	BeastNames[12] = "Dragons"
	BeastNames[13] = "Giants"
	BeastNames[14] = "Trolls"
	BeastNames[15] = "Draugrs"
	BeastNames[16] = "Sabre Cats"
	BeastNames[17] = ""
	BeastNames[18] = ""
	BeastNames[19] = ""
	BeastNames[20] = ""
	
EndFunction 

Function IncrementStatCreatureSex(actor[] ActorList)
;Receives the information about the last sex act from the sex tracker and updates the sex diary
;For each actor that is not the player, get its race and increase the stats

	Int index = 0
	Int raceindex = 0
	While (index < ActorList.Length)
		If (ActorList[index] != Game.GetPlayer())				
				If (SLAdventures_DogList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 0
				ElseIf (SLAdventures_HorseList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 1
				ElseIf (SLAdventures_WolfList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 2
				ElseIf (SLAdventures_BearList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 3
				ElseIf (SLAdventures_DeerList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 4
				ElseIf (SLAdventures_CowList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 5
				ElseIf (SLAdventures_GoatList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 6
				ElseIf (SLAdventures_SkeeverList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 7
				ElseIf (SLAdventures_FalmerList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 8
				ElseIf (SLAdventures_SpiderList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 9
				ElseIf (SLAdventures_ChaurusList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 10
				ElseIf (SLAdventures_WerewolfList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 11
				ElseIf (SLAdventures_DragonList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 12
				ElseIf (SLAdventures_GiantList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 13
				ElseIf (SLAdventures_TrollList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 14
				ElseIf (SLAdventures_DraugrList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 15
				ElseIf (SLAdventures_SabreCatList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 16
				ElseIf (SLAdventures_VampireLordList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 17
				ElseIf (SLAdventures_GargoyleList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 18
				ElseIf (SLAdventures_DeathHoundList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 19
				ElseIf (SLAdventures_RieklingList.HasForm(ActorList[index].GetRace()) == True)
					raceindex = 20
				Else
					raceindex = -1
				EndIf
				
				If (raceindex != -1) ;Skip the actor if its race was not found in any of these lists
					iBeastPartners[raceindex] = iBeastPartners[raceindex] + 1
				EndIf 	
						
		EndIf
		index += 1
	EndWhile 
EndFunction 

Function IncrementStatTimesUsedDuringSleep(Int Amount = 1)
	iTimesUsedDuringSleep += Amount
EndFunction 

Function IncrementCrimeStat(Int Crime)
	
	If (Crime == CRIME_NUDE_IN_PUBLIC) 
		iReportsNudity += 1
	ElseIf (Crime == CRIME_NOT_NUDE) 
		iReportsNotNude += 1
	ElseIf (Crime == CRIME_COVERED_IN_CUM) 
		iReportsCum += 1
	ElseIf (Crime == CRIME_MASTURBATING) 
		iReportsMasturbation += 1
	ElseIf (Crime == CRIME_SEX) 
		iReportsSex += 1
	ElseIf (Crime == CRIME_HOMO) 
		iReportsHomo += 1
	ElseIf (Crime == CRIME_BEAST) 
		iReportsBeast += 1
	ElseIf (Crime == CRIME_ARMED) || (Crime == CRIME_ARMED_DURING_COMBAT) || (Crime == CRIME_HAS_WEAPONS) || (Crime == CRIME_HAS_WEAPONS_DURING_COMBAT) 
		iReportsArmed += 1
	ElseIf (Crime == CRIME_OUT_AT_NIGHT)
		iReportsOutAtNight += 1
	ElseIf (Crime == CRIME_COLLARED)
		iReportsCollared += 1
	ElseIf (Crime == CRIME_NOT_COLLARED)
		iReportsNotCollared += 1
	ElseIf (Crime == CRIME_USED_MAGIC)
		iReportsUsedMagic += 1
	EndIf

EndFunction 

Function DLCOrModInstalled(string DLCModName, Bool IsInstalled)
	;debug.notification("SexDiary.DLCOrModInstalled()")
	If (DLCModName == "Dragonborn.esm")
		If (IsInstalled == True)
			BeastNames[20] = "Rieklings"
		Else
			BeastNames[20] = ""
		EndIf
	ElseIf (DLCModName == "Dawnguard.esm")
		If (IsInstalled == True)
			BeastNames[17] = "Vampire Lords"
			BeastNames[18] = "Gargoyles"
			BeastNames[19] = "Death Hounds"
		Else
			BeastNames[17] = ""
			BeastNames[18] = ""
			BeastNames[19] = ""
		EndIf
	EndIf
	
EndFunction 


;Variables and Properties - no functions after this line 
;Variables

String[] Property BeastNames Auto Hidden 

;Properties
SLAdventures_MCM_Script Property MCM Auto 
SLAdventures_Utility Property SLA_Utility Auto 
SexLabFramework Property Sexlab Auto 
 
Int[] Property iBeastPartners Auto Hidden

Int Property iReportsNudity Auto Hidden 
Int Property iReportsNotNude Auto Hidden 
Int Property iReportsCum Auto Hidden 
Int Property iReportsMasturbation Auto Hidden 
Int Property iReportsSex Auto Hidden 
Int Property iReportsHomo Auto Hidden 
Int Property iReportsBeast Auto Hidden 
Int Property iReportsArmed Auto Hidden 
Int Property iReportsOutAtNight Auto Hidden 
Int Property iReportsCollared Auto Hidden 
Int Property iReportsNotCollared Auto Hidden 
Int Property iReportsUsedMagic Auto Hidden 

Int Property iTimesUsedDuringSleep = 0 Auto Hidden

Faction Property SLAdventures_RapedByFaction Auto  

FormList Property SLAdventures_NPCRaces Auto 

FormList Property SLAdventures_DogList Auto 
FormList Property SLAdventures_HorseList Auto 
FormLIst Property SLAdventures_WolfList Auto 
FormList Property SLAdventures_BearList Auto
 
FormList Property SLAdventures_DeerList Auto 
FormList Property SLAdventures_CowList Auto 
FormList Property SLAdventures_GoatList Auto 
FormList Property SLAdventures_SkeeverList Auto
 
FormList Property SLAdventures_FalmerList Auto 
FormList Property SLAdventures_SpiderList Auto 
FormList Property SLAdventures_ChaurusList Auto 
FormList Property SLAdventures_WerewolfList Auto 

FormList Property SLAdventures_DragonList Auto 
FormList Property SLAdventures_GiantList Auto 
FormList Property SLAdventures_TrollList Auto 
FormList Property SLAdventures_DraugrList Auto 

FormList Property SLAdventures_SabreCatList Auto 

;DLC1
FormList Property SLAdventures_VampireLordList Auto 
FormList Property SLAdventures_GargoyleList Auto
FormList Property SLAdventures_DeathHoundList Auto  

;DLC2
FormList Property SLAdventures_RieklingList Auto 

;Read-Only Properties 
Int Property CRIME_NUDE_IN_PUBLIC = 10 AutoReadOnly
Int Property CRIME_NOT_NUDE = 11 AutoReadOnly
Int Property CRIME_COVERED_IN_CUM = 20 AutoReadOnly 
Int Property CRIME_MASTURBATING = 30 AutoReadOnly 
Int Property CRIME_SEX = 40 AutoReadOnly 
Int Property CRIME_HOMO = 50 AutoReadOnly 
Int Property CRIME_BEAST = 60 AutoReadOnly 
Int Property CRIME_ARMED = 70 AutoReadOnly 
Int Property CRIME_HAS_WEAPONS = 71 AutoReadOnly 
Int Property CRIME_ARMED_DURING_COMBAT = 72 AutoReadOnly 
Int Property CRIME_HAS_WEAPONS_DURING_COMBAT = 73 AutoReadOnly 
Int Property CRIME_OUT_AT_NIGHT = 80 AutoReadOnly 
Int Property CRIME_COLLARED = 90 AutoReadOnly 
Int Property CRIME_NOT_COLLARED = 91 AutoReadOnly 
Int Property CRIME_USED_MAGIC = 100 AutoReadOnly 

;Deprecated - These properties and functions will be removed in a future version of Sexlab Adventures.

;0.71
Function UpdateSexCrimeReports(Int Crime, Bool HasNudityLaw = False, Int Reports = 1)
EndFunction 
Int[] Property iSexCrimeReports Auto Hidden 
Int Property iSexCrimeReportsNudityLaw Auto Hidden 