Scriptname SLAdventures_SexTracker extends Quest  

;Events

Event OnUpdate()

	If (bIsInGangRape == True) && (bIsGangRapeDone == True)
		If (RapeController.StartSexScene(Self) == False)
			RegisterForSingleUpdate(5.0)
		Else
			bIsGangRapeDone = False
		EndIf
	EndIf

EndEvent

Event SexlabSceneStart(Form ActorRef, Int tid)

	Actor Tracked = ActorRef as Actor
	sslThreadController Thread = SexLab.GetController(tid) 
	sslBaseAnimation Animation = Thread.Animation
	Actor[] actorList = Thread.Positions		
	Int NumActors = actorList.Length			
	
	bIsInOralScene = Animation.IsOral
	bIsInVaginalScene = Animation.IsVaginal
	bIsInAnalScene = Animation.IsAnal
	bIsUsingBed = Thread.UsingBed
	
	bIsVictim = SexLab.IsVictim(tid, Tracked)
	
	Int TrackedGender = Sexlab.GetGender(Tracked)
	
	Int NumBeasts = Sexlab.CreatureCount(actorList) 
	Int NumMale = Sexlab.MaleCount(actorList) 
	Int NumFemale = Sexlab.FemaleCount(actorList) 
	
	If (TrackedGender == 1)							;is female
		NumFemale = NumFemale - 1
	Else											;is male
		NumMale = NumMale - 1
	EndIf
	
	If (NumActors == 1)
		iHasSex = 2							;is masturbating
	ElseIf (NumBeasts >= 1)
		iHasSex = 5							;does the beast
	ElseIf (TrackedGender == 1) && (NumFemale >= 1)
		iHasSex = 4							;lesbian
	ElseIf (TrackedGender == 0) && (NumMale >= 1)
		iHasSex = 4							;gay ;known issue: Male tracked actors are counted as gay in "2 males on 1 female"-animations and the like.
	Else 
		iHasSex = 3							;straight
	EndIf 
	
EndEvent 

Event SexlabSceneEnd(Form ActorRef, Int tid)
	
	sslThreadController Thread = SexLab.GetController(tid) 
	sslBaseAnimation Animation = Thread.Animation	
	Actor[] actorList = Thread.Positions			
	Int NumActors = actorList.Length				
	
	bIsInOralScene = False
	bIsInVaginalScene = False
	bIsInAnalScene = False
	bIsUsingBed = False
	
	bIsVictim = False
	iHasSex = 0
	
	If (bIsInGangRape == True) 
		RapeController.HandleEndOfSexScene(Self, actorList, Animation.IsOral, Animation.IsVaginal, Animation.IsAnal)
	EndIf
	
EndEvent

;Functions

Function RegisterSexlab()
	RegisterForModEvent(EventString + "_Start", "SexlabSceneStart")
	RegisterForModEvent(EventString + "_End", "SexlabSceneEnd")
EndFunction

Bool Function Track(Actor akActor)
	If (akActor != Player) 
		TrackedActor = akActor
		Sexlab.TrackActor(TrackedActor, EventString)
		StorePosition()
		akActor.AddToFaction(SLAdventures_GangRapeVictimFaction)
		return True
	Else 
		return False
	EndIf
EndFunction

Bool Function UnTrack()
	If (TrackedActor != Player)
		Sexlab.UntrackActor(TrackedActor, EventString)
		TrackedActor.RemoveFromFaction(SLAdventures_GangRapeVictimFaction)
		RedressActor()
		TrackedActor = none
		return True
	Else
		return False
	EndIf
EndFunction

Actor Function GetTrackedActor()
	return TrackedActor
EndFunction

Bool Function IsInScene() 
	return Sexlab.IsActorActive(TrackedActor)
EndFunction 

Function StorePosition()
	fPosX = TrackedActor.X
	fPosY = TrackedActor.Y
	fPosZ = TrackedActor.Z
EndFunction

Function RestorePosition()
	TrackedActor.SetPosition(fPosX, fPosY, fPosZ)
EndFunction

Function StripActor(String Type, Actor[] Thieves, Int NumThieves = 0, Bool RemoveQuestItems = False, Bool UseSexlabStrip = True)
	;Types: Strip, Drop, Steal, Destroy.
	
	If (Type == "Steal") 
		If (Thieves[0] == none)
			Type = "Strip"
		ElseIf (NumThieves < 1) 
			NumThieves = Thieves.Length
			If (NumThieves == 0) 
				Type = "Strip"
			EndIf
		EndIf
	EndIf
	
	If (UseSexlabStrip == True)
		Form[] Items = Sexlab.StripActor(TrackedActor, TrackedActor, False, False)
		If (Type == "Drop")	
			Int index = Items.Length
			While (index > 0) 
				index -= 1
				If (Items[index] as ObjectReference == none) || (RemoveQuestItems == True)
					TrackedActor.DropObject(Items[index])
				EndIf
			EndWhile
		ElseIf (Type == "Steal")	
			Int index = Items.Length
			While (index > 0) 
				index -= 1
				If (Items[index] as ObjectReference == none) || (RemoveQuestItems == True)
					Thieves[Utility.RandomInt(0, (NumThieves - 1))].AddItem(Items[index])
					TrackedActor.RemoveItem(Items[index], 1, True)
				EndIf
			EndWhile
		ElseIf (Type == "Destroy")	
			Int index = Items.Length
			While (index > 0) 
				index -= 1
				If (Items[index] as ObjectReference == none) || (RemoveQuestItems == True)
					TrackedActor.RemoveItem(Items[index], 1, True)
				EndIf
			EndWhile
		ElseIf (Type == "Strip") && (StrippedItems != none)
			StrippedItems.Revert()
			Int index = Items.Length
			While (index > 0) 
				index -= 1
				StrippedItems.AddForm(Items[index])
			EndWhile
		EndIf
	Else 
		Spell akSpell
		Weapon akWeapon
		Armor akShield
		Ammo akAmmo
		Form akForm 
		If (StrippedItems != none) 
			StrippedItems.Revert()
		EndIf
	
		While ((TrackedActor.GetEquippedWeapon(True) != none) || (TrackedActor.GetEquippedWeapon(False) != none) || (TrackedActor.GetEquippedSpell(1) != none) || (TrackedActor.GetEquippedSpell(0) != none))
		
			akSpell = TrackedActor.GetEquippedSpell(1)
			If (akSpell != none)
				TrackedActor.UnequipSpell(akSpell, 1)			
			EndIf			
			akWeapon = TrackedActor.GetEquippedWeapon(True)
			If (akWeapon != none) && (Sexlab.IsStrippable(akWeapon) == True)
				If (Type == "Strip")
					TrackedActor.UnequipItem(akWeapon, False, True)
					If (StrippedItems != none) 
						StrippedItems.AddForm(akForm)
					EndIf
				ElseIf (Type == "Drop")
					TrackedActor.DropObject(akWeapon)
				ElseIf (Type == "Steal") && ((RemoveQuestItems == True) || ((akWeapon as Form) as ObjectReference == none))
					Thieves[Utility.RandomInt(0, (NumThieves - 1))].AddItem(akWeapon)
					TrackedActor.RemoveItem(akWeapon, 1, True)
				ElseIf (Type == "Destroy") && ((RemoveQuestItems == True) || ((akWeapon as Form) as ObjectReference == none))
					TrackedActor.RemoveItem(akWeapon, 1, True)
				EndIf				
			EndIf			
			akShield = TrackedActor.GetEquippedShield()
			If (akShield != none) && (Sexlab.IsStrippable(akShield) == True)
				If (Type == "Strip")
					TrackedActor.UnequipItem(akShield, False, True)
					If (StrippedItems != none) 
						StrippedItems.AddForm(akForm)
					EndIf
				ElseIf (Type == "Drop")
					TrackedActor.DropObject(akShield)
				ElseIf (Type == "Steal") && ((RemoveQuestItems == True) || ((akShield as Form) as ObjectReference == none))
					Thieves[Utility.RandomInt(0, (NumThieves - 1))].AddItem(akShield)
					TrackedActor.RemoveItem(akShield, 1, True)
				ElseIf (Type == "Destroy") && ((RemoveQuestItems == True) || ((akShield as Form) as ObjectReference == none))
					TrackedActor.RemoveItem(akShield, 1, True)
				EndIf
			EndIf				
			akSpell = TrackedActor.GetEquippedSpell(0)
			If (akSpell != none) 
				TrackedActor.UnequipSpell(akSpell, 0)			
			EndIf
			akWeapon = TrackedActor.GetEquippedWeapon(False)
			If (akWeapon != none) && (Sexlab.IsStrippable(akWeapon) == True)
				If (Type == "Strip")
					TrackedActor.UnequipItem(akWeapon, False, True)
					If (StrippedItems != none) 
						StrippedItems.AddForm(akForm)
					EndIf
				ElseIf (Type == "Drop")
					TrackedActor.DropObject(akWeapon)
				ElseIf (Type == "Steal") && ((RemoveQuestItems == True) || ((akWeapon as Form) as ObjectReference == none))
					Thieves[Utility.RandomInt(0, (NumThieves - 1))].AddItem(akWeapon)
					TrackedActor.RemoveItem(akWeapon, 1, True)
				ElseIf (Type == "Destroy") && ((RemoveQuestItems == True) || ((akWeapon as Form) as ObjectReference == none))
					TrackedActor.RemoveItem(akWeapon, 1, True)
				EndIf			
			EndIf
			If TrackedActor.GetEquippedItemType(0) == 11		
				TrackedActor.UnequipItem(Torch01, True)
			EndIf
		EndWhile
	
		int index = SLAdventures_AmmoList.GetSize()
		While (index > 0)
	
			index -= 1
			akAmmo = SLAdventures_AmmoList.GetAt(index) As Ammo
			If TrackedActor.IsEquipped(akAmmo)
				If (Type == "Strip")
					TrackedActor.UnequipItem(akAmmo, abSilent = true)
				ElseIf (Type == "Drop")
					TrackedActor.DropObject(akAmmo, TrackedActor.GetItemCount(akAmmo))
				ElseIf (Type == "Steal")
					Thieves[Utility.RandomInt(0, (NumThieves - 1))].AddItem(akAmmo, TrackedActor.GetItemCount(akAmmo))
					TrackedActor.RemoveItem(akAmmo, TrackedActor.GetItemCount(akAmmo), True)
				ElseIf (Type == "Destroy")
					TrackedActor.RemoveItem(akAmmo, TrackedActor.GetItemCount(akAmmo), True)
				EndIf
			EndIf
			
		EndWhile		

		int i = 31	
		While i >= 0
			akForm = TrackedActor.GetWornForm(Armor.GetMaskForSlot(i + 30))
			If (akForm  != none) && (Sexlab.IsStrippable(akForm) == True)
				If (Type == "Strip")
					TrackedActor.UnequipItem(akForm, false, true)
					If (StrippedItems != none) 
						StrippedItems.AddForm(akForm)
					EndIf
				ElseIf (Type == "Drop")
					TrackedActor.DropObject(akForm)
				ElseIf (Type == "Steal") && ((RemoveQuestItems == True) || (akForm as ObjectReference == none))
					Thieves[Utility.RandomInt(0, (NumThieves - 1))].AddItem(akForm)
					TrackedActor.RemoveItem(akForm, 1, True)
				ElseIf (Type == "Destroy") && ((RemoveQuestItems == True) || (akForm as ObjectReference == none))
					TrackedActor.RemoveItem(akForm, 1, True)
				EndIf
			EndIf
			i -= 1
		EndWhile
	EndIf
	
EndFunction

Function RedressActor()

	If (StrippedItems != none) && (StrippedItems.GetSize() > 0)
		Form akForm
		While (StrippedItems.GetSize() > 0)
			akForm = StrippedItems.GetAt(0)
			If (TrackedActor.GetItemCount(akForm) > 0)
				TrackedActor.EquipItem(akForm, abSilent = True)
			EndIf
			StrippedItems.RemoveAddedForm(akForm)
		EndWhile
	EndIf

EndFunction

;Variables and Properties - no functions after this line

;Gangrape related
Float fPosX 
Float fPosY 
Float fPosZ 

SexlabFramework Property Sexlab Auto 
SLAdventures_GangRapeController Property RapeController Auto 
FormList Property StrippedItems Auto 
String Property EventString Auto 		;Unique for each instance of this script
Actor Property TrackedActor Auto 
Actor Property Player Auto 
Light Property Torch01 Auto  
FormList Property SLAdventures_AmmoList Auto 
Faction Property SLAdventures_GangRapeVictimFaction Auto 

Int Property iHasSex = 0 	Auto Hidden ;0 = no sex, 1 = unused, 2 = masturbates, 3 = straight, 4 = homo, 5 = beast 
Bool Property bIsVictim = False Auto Hidden 
Bool Property bIsInOralScene = False Auto Hidden 
Bool Property bIsInAnalScene = False Auto Hidden 
Bool Property bIsInVaginalScene = False Auto Hidden 
Bool Property bIsUsingBed = False Auto Hidden 

;Gangrape related
Bool Property bIsInGangRape = False Auto Hidden 
Bool Property bIsGangRapeDone = True Auto Hidden 
Bool Property bIsReserved = False Auto Hidden 
Bool Property bIsConsent = False Auto Hidden 
Bool Property bUseRestrainedAnimations = False Auto Hidden 