Scriptname SLAdventures_CharacterRenamer extends Quest 

;Functions

Function RenameCharacter(String sNewName = "", Bool bUsePreName = False, Bool bUsePostName = False)

	String sFullName 
	If (sNewName == "")
		sNewName = sName
	EndIf
	If (bUsePreName == True) && (sPreName != "")
		sFullName = sPreName + " " + sNewName
	Else
		sFullName = sNewName
	EndIf
	If (bUsePostName == True) && (sPostName != "")
		sFullName = sFullName + " " + sPostName
	EndIf
	Game.GetPlayer().GetActorBase().SetName(sFullName)
	
EndFunction 

Function SetCRName(String sNewString = "")

	If (sNewString != "")
		sName = sNewString
	Else
		sName = (Game.GetPlayer().GetActorBase().GetName())		;Just to make sure sName is not empty
	EndIf 
	
EndFunction

Function SetPreName(String sNewString)

	sPreName = sNewString
	
EndFunction 

Function SetPostName(String sNewString)

	sPostName = sNewString
	
EndFunction 

String Function GetCRName()

	return sName	;Because GetName() does not return the "name" alone
	
EndFunction 

String Function GetPreName()

	return sPreName
	
EndFunction 

String Function GetPostName()

	return sPostName
	
EndFunction 

String Function GetFullName()

	return (Game.GetPlayer().GetActorBase().GetName())		;Same as calling GetName() directly.
	
EndFunction

;Variables and Properties - no functions after this line 
;Variables
String sPreName = ""		;A string added before the name given to RenameCharacter() if the correspoding bool is set to true
String sPostName = "" 	;A string added after the name given to RenameCharacter() if the correspoding bool is set to true
;This functionality is currently unused!
String sName 			;A string that stores the name provided by RenameCharacter() so you can use GetCRName().