Scriptname SLAdventures_CrimeLawsScript extends Quest 
;There are 10 instances of this script, one for each hold. The Script holds the laws for the hold, 
;the crime amount and report timers and provides a function to report the player for a number of crimes. 

;Events
Event OnUpdate() 
	;debug.notification(CrimeFaction.GetName() + " OnUpdate")
	;debug.notification("Sexlab.IsActorActive: " + Sexlab.IsActorActive(Game.GetPlayer()))
	;debug.notification(Game.IsMovementControlsEnabled())
	;debug.notification(Game.IsFightingControlsEnabled())
	;debug.notification(Rape.bPlayerIsGangRaped)
	If (Sexlab.IsActorActive(Player) == False) && (Game.IsMovementControlsEnabled() == True) && (Rape.bPlayerIsGangRaped == False) 
		ApplyBounty()
	ElseIf (iCurrentBounty > 0) 
		RegisterForSingleUpdate(2.0)
	EndIf
EndEvent 

;Functions

Int Function Report(Int[] Crimes, SLAdventures_CrimeScript CrimeScript = none)

	;debug.notification("Report()")
	Int TotalBounty = 0
	Int index = 0
	While (index < Crimes.Length) 
		If (Crimes[index] == 0)		
		ElseIf (Crimes[index] == CRIME_NUDE_IN_PUBLIC) 
			If (bNudityIsACrime) && (bNudityInverted == False) && (iNudityBounty > 0) \
			&& ((bNudityThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& ((bNudityToleratedAtNight == False) || (SLA_Utility.IsNight() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastNudityReport) >= fNudityTimeBetweenReports)
				AddBounty(iNudityBounty)
				TotalBounty += iNudityBounty
				Statistics.IncrementCrimeStat(CRIME_NUDE_IN_PUBLIC)
				fLastNudityReport = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Crimes[index] == CRIME_NOT_NUDE) 
			If (bNudityIsACrime) && (bNudityInverted == True) && (iNudityBounty > 0) \
			&& ((bNudityThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& ((bNudityToleratedAtNight == False) || (SLA_Utility.IsNight() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastNudityReport) >= fNudityTimeBetweenReports)
				AddBounty(iNudityBounty)
				TotalBounty += iNudityBounty
				Statistics.IncrementCrimeStat(CRIME_NOT_NUDE)
				fLastNudityReport = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Crimes[index] == CRIME_COVERED_IN_CUM) 
			If (bCumIsACrime) && (iCumBounty > 0) \
			&& ((bCumThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& ((bCumToleratedAtNight == False) || (SLA_Utility.IsNight() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastCumReport) >= fCumTimeBetweenReports)
				AddBounty(iCumBounty)
				TotalBounty += iCumBounty
				Statistics.IncrementCrimeStat(CRIME_COVERED_IN_CUM)
				fLastCumReport = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Crimes[index] == CRIME_MASTURBATING)
			If (bMasturbationIsACrime) && (iMasturbationBounty > 0) \
			&& ((bMasturbationThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& ((bMasturbationToleratedAtNight == False) || (SLA_Utility.IsNight() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastMasturbationReport) >= fMasturbationTimeBetweenReports)
				AddBounty(iMasturbationBounty)
				TotalBounty += iMasturbationBounty
				Statistics.IncrementCrimeStat(CRIME_MASTURBATING)
				fLastMasturbationReport = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Crimes[index] == CRIME_SEX)
			If (bSexIsACrime) && (iSexBounty > 0) \
			&& ((bSexThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& ((bSexToleratedAtNight == False) || (SLA_Utility.IsNight() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastSexReport) >= fSexTimeBetweenReports)
				Int iModdedBounty = iSexBounty
				If (PlayerSexTracker.bIsVictim) 
					iModdedBounty = (iModdedBounty * fSexModIfForced) as Int
				EndIf
				AddBounty((iModdedBounty) as Int)
				TotalBounty += (iModdedBounty) as Int
				Statistics.IncrementCrimeStat(CRIME_SEX)
				fLastSexReport = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Crimes[index] == CRIME_HOMO) 
			If (bSexIsACrime) && (iSexBounty > 0) \
			&& ((bSexThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& ((bSexToleratedAtNight == False) || (SLA_Utility.IsNight() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastSexReport) >= fSexTimeBetweenReports)
				Int iModdedBounty = iSexBounty
				If (PlayerSexTracker.bIsVictim) 
					iModdedBounty = (iModdedBounty * fSexModIfForced) as Int
				EndIf
				AddBounty((iModdedBounty * fSexModIfHomo) as Int)
				TotalBounty += (iModdedBounty * fSexModIfHomo) as Int
				Statistics.IncrementCrimeStat(CRIME_HOMO)
				fLastSexReport = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Crimes[index] == CRIME_BEAST) 
			If (bSexIsACrime) && (iSexBounty > 0) \
			&& ((bSexThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& ((bSexToleratedAtNight == False) || (SLA_Utility.IsNight() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastSexReport) >= fSexTimeBetweenReports)
				Int iModdedBounty = iSexBounty
				If (PlayerSexTracker.bIsVictim) 
					iModdedBounty = (iModdedBounty * fSexModIfForced) as Int
				EndIf
				AddBounty((iModdedBounty * fSexModIfBeast) as Int)
				TotalBounty += (iModdedBounty * fSexModIfBeast) as Int
				Statistics.IncrementCrimeStat(CRIME_BEAST)
				fLastSexReport = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Crimes[index] == CRIME_ARMED) 
			If (bArmedIsACrime) && (iArmedBounty > 0) \
			&& ((bArmedThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& ((bArmedToleratedAtNight == False) || (SLA_Utility.IsNight() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastArmedReport) >= fArmedTimeBetweenReports)
				AddBounty(iArmedBounty)
				TotalBounty += iArmedBounty
				Statistics.IncrementCrimeStat(CRIME_ARMED)
				fLastArmedReport = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Crimes[index] == CRIME_ARMED_DURING_COMBAT) 
			If (bArmedIsACrime) && (bArmedNotDuringCombat == False) && (iArmedBounty > 0) \
			&& ((bArmedThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& ((bArmedToleratedAtNight == False) || (SLA_Utility.IsNight() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastArmedReport) >= fArmedTimeBetweenReports)
				AddBounty(iArmedBounty)
				TotalBounty += iArmedBounty
				Statistics.IncrementCrimeStat(CRIME_ARMED_DURING_COMBAT)
				fLastArmedReport = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Crimes[index] == CRIME_HAS_WEAPONS) 
			If (bArmedIsACrime) && (bArmedPossessionIsACrime) && (iArmedBounty > 0) \
			&& ((bArmedThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& ((bArmedToleratedAtNight == False) || (SLA_Utility.IsNight() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastArmedReport) >= fArmedTimeBetweenReports)
				AddBounty(iArmedBounty)
				TotalBounty += iArmedBounty
				Statistics.IncrementCrimeStat(CRIME_HAS_WEAPONS)
				fLastArmedReport = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Crimes[index] == CRIME_HAS_WEAPONS_DURING_COMBAT) 
			If (bArmedIsACrime) && (bArmedNotDuringCombat == False) && (bArmedPossessionIsACrime) && (iArmedBounty > 0) \
			&& ((bArmedThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& ((bArmedToleratedAtNight == False) || (SLA_Utility.IsNight() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastArmedReport) >= fArmedTimeBetweenReports)
				AddBounty(iArmedBounty)
				TotalBounty += iArmedBounty
				Statistics.IncrementCrimeStat(CRIME_HAS_WEAPONS_DURING_COMBAT)
				fLastArmedReport = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Crimes[index] == CRIME_OUT_AT_NIGHT) 
			Float fTime = SLA_Utility.GetTimeOfDay()
			If (bNightIsACrime) && (iNightBounty > 0) \
			&& ((fTime > fLateNightBegin) || (fTime < fLateNightEnd)) \
			&& ((bNightThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastOutsideAtNightReport) >= fNightTimeBetweenReports)
				AddBounty(iNightBounty)
				TotalBounty += iNightBounty
				Statistics.IncrementCrimeStat(CRIME_OUT_AT_NIGHT)
				fLastOutsideAtNightReport = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Crimes[index] == CRIME_COLLARED) 
			If (bCollaredIsACrime) && (iCollaredBounty > 0) && (bCollaredInverted == False) \
			&& ((bCollaredThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& ((bCollaredToleratedAtNight == False) || (SLA_Utility.IsNight() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastCollaredReport) >= fCollaredTimeBetweenReports)
				AddBounty(iCollaredBounty)
				TotalBounty += iCollaredBounty
				Statistics.IncrementCrimeStat(CRIME_COLLARED)
				fLastCollaredReport = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Crimes[index] == CRIME_NOT_COLLARED)
			If (bCollaredIsACrime) && (iCollaredBounty > 0) && (bCollaredInverted == True) \
			&& ((bCollaredThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& ((bCollaredToleratedAtNight == False) || (SLA_Utility.IsNight() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastCollaredReport) >= fCollaredTimeBetweenReports)
				AddBounty(iCollaredBounty)
				TotalBounty += iCollaredBounty
				Statistics.IncrementCrimeStat(CRIME_NOT_COLLARED)
				fLastCollaredReport = Utility.GetCurrentGameTime()
			EndIf
		ElseIf (Crimes[index] == CRIME_USED_MAGIC) 
			If (bMagicIsACrime) && (iMagicBounty > 0) \
			&& ((bMagicThaneImmunity == False) || (SLA_Utility.IsThane() == False)) \
			&& ((bMagicToleratedAtNight == False) || (SLA_Utility.IsNight() == False)) \
			&& (SLA_Utility.GetHoursPassed(fLastUseOfMagicReport) >= fMagicTimeBetweenReports) \
			&& ((bMagicNotDuringCombat == False) || (Player.IsInCombat() == False))
				AddBounty(iMagicBounty)
				TotalBounty += iMagicBounty
				Statistics.IncrementCrimeStat(CRIME_USED_MAGIC)
				fLastUseOfMagicReport = Utility.GetCurrentGameTime()
			EndIf
		EndIf
	index += 1
	EndWhile
	;Todo Update Statistics 
	;debug.notification("Bounty: " + iCurrentBounty)
	RegisterForSingleUpdate(2.0)
	return TotalBounty
	
EndFunction 

Int Function ReportSingleCrime(Int Crime)

	RegisterForSingleUpdate(2.0)

EndFunction 

;Todo move the crime-specific sections in Report() into their own functions.
; This way they are callable by ReportSingleCrime()

Function AddBounty(Int iAmount) 
	If ((iCurrentBounty + iAmount) >= 1000) 
		iCurrentBounty = 1000
	Else
		iCurrentBounty += iAmount
	EndIf
EndFunction 

Function ApplyBounty() 
	;debug.notification("ApplyBounty()")
	If (iCurrentBounty > 0) 
		CrimeFaction.ModCrimeGold(iCurrentBounty)
		Debug.Notification(iCurrentBounty + " Bounty added to " + CrimeFaction.GetName())
		iCurrentBounty = 0
	EndIf
EndFunction 

Function ImportOptionsFromHold(SLAdventures_CrimeLawsScript Hold)

	bNudityIsACrime = Hold.bNudityIsACrime
	iNudityBounty = Hold.iNudityBounty
	bNudityThaneImmunity = Hold.bNudityThaneImmunity
	bNudityToleratedAtNight =Hold.bNudityToleratedAtNight
	bNudityInverted = Hold.bNudityInverted
	fNudityTimeBetweenReports = Hold.fNudityTimeBetweenReports
	
	bCumIsACrime = Hold.bCumIsACrime
	iCumBounty = Hold.iCumBounty
	bCumThaneImmunity = Hold.bCumThaneImmunity
	bCumToleratedAtNight = Hold.bCumToleratedAtNight
	fCumTimeBetweenReports = Hold.fCumTimeBetweenReports
	
	bCollaredIsACrime = Hold.bCollaredIsACrime
	iCollaredBounty = Hold.iCollaredBounty
	bCollaredThaneImmunity = Hold.bCollaredThaneImmunity
	bCollaredToleratedAtNight = Hold.bCollaredToleratedAtNight
	fCollaredTimeBetweenReports = Hold.fCollaredTimeBetweenReports
	
	bMasturbationIsACrime = Hold.bMasturbationIsACrime
	iMasturbationBounty = Hold.iMasturbationBounty
	bMasturbationThaneImmunity = Hold.bMasturbationThaneImmunity
	bMasturbationToleratedAtNight = Hold.bMasturbationToleratedAtNight
	fMasturbationTimeBetweenReports = Hold.fMasturbationTimeBetweenReports
	
	bSexIsACrime = Hold.bSexIsACrime
	iSexBounty = Hold.iSexBounty
	bSexThaneImmunity = Hold.bSexThaneImmunity
	bSexToleratedAtNight = Hold.bSexToleratedAtNight
	fSexModIfForced = Hold.fSexModIfForced
	fSexModIfHomo = Hold.fSexModIfHomo
	fSexModIfBeast = Hold.fSexModIfBeast
	fSexTimeBetweenReports = Hold.fSexTimeBetweenReports

	bArmedIsACrime = Hold.bArmedIsACrime
	iArmedBounty = Hold.iArmedBounty
	bArmedThaneImmunity = Hold.bArmedThaneImmunity
	bArmedToleratedAtNight = Hold.bArmedToleratedAtNight
	fArmedTimeBetweenReports = Hold.fArmedTimeBetweenReports
 
	bMagicIsACrime = Hold.bMagicIsACrime
	iMagicBounty = Hold.iMagicBounty
	bMagicThaneImmunity = Hold.bMagicThaneImmunity
	bMagicToleratedAtNight = Hold.bMagicToleratedAtNight
	fMagicTimeBetweenReports = Hold.fMagicTimeBetweenReports
 
	bNightIsACrime = Hold.bNightIsACrime
	iNightBounty = Hold.iNightBounty
	bNightThaneImmunity = Hold.bNightThaneImmunity
	fNightTimeBetweenReports = Hold.fNightTimeBetweenReports
	
EndFunction

Function SaveMCMOptions(String FileName)

	String FactionName = CrimeFaction.GetName()
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "NudityIsACrime", bNudityIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, FactionName + "NudityBounty", iNudityBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "NudityThaneImmunity", bNudityThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "NudityToleratedAtNight", bNudityToleratedAtNight)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "NudityInverted", bNudityInverted)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, FactionName + "NudityTimeBetweenReports", fNudityTimeBetweenReports)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "CumIsACrime", bCumIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, FactionName + "CumBounty", iCumBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "CumThaneImmunity", bCumThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "CumToleratedAtNight", bCumToleratedAtNight)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, FactionName + "CumTimeBetweenReports", fCumTimeBetweenReports)

	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "CollaredIsACrime", bCollaredIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, FactionName + "CollaredBounty", iCollaredBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "CollaredThaneImmunity", bCollaredThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "CollaredToleratedAtNight", bCollaredToleratedAtNight)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "CollaredInverted", bCollaredInverted)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, FactionName + "CollaredTimeBetweenReports", fCollaredTimeBetweenReports)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "MasturbationIsACrime", bMasturbationIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, FactionName + "MasturbationBounty", iMasturbationBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "MasturbationThaneImmunity", bMasturbationThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "MasturbationToleratedAtNight", bMasturbationToleratedAtNight)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, FactionName + "MasturbationTimeBetweenReports", fMasturbationTimeBetweenReports)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "SexIsACrime", bSexIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, FactionName + "SexBounty", iSexBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "SexThaneImmunity", bSexThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "SexToleratedAtNight", bSexToleratedAtNight)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, FactionName + "SexModIfForced", fSexModIfForced)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, FactionName + "SexModIfHomo", fSexModIfHomo)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, FactionName + "SexModIfBeast", fSexModIfBeast)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, FactionName + "SexTimeBetweenReports", fSexTimeBetweenReports)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "ArmedIsACrime", bArmedIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, FactionName + "ArmedBounty", iArmedBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "ArmedThaneImmunity", bArmedThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "ArmedToleratedAtNight", bArmedToleratedAtNight)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, FactionName + "ArmedTimeBetweenReports", fArmedTimeBetweenReports)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "ArmedAllowDuringCombat", bArmedNotDuringCombat)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "ArmedPossessionIsACrime", bArmedPossessionIsACrime)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "MagicIsACrime", bMagicIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, FactionName + "MagicBounty", iMagicBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "MagicThaneImmunity", bMagicThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "MagicToleratedAtNight", bMagicToleratedAtNight)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, FactionName + "MagicTimeBetweenReports", fMagicTimeBetweenReports)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "MagicAllowDuringCombat", bMagicNotDuringCombat)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "NightIsACrime", bNightIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, FactionName + "NightBounty", iNightBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, FactionName + "NightThaneImmunity", bNightThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, FactionName + "NightTimeBetweenReports", fNightTimeBetweenReports)
	
EndFunction 

Function LoadMCMOptions(String FileName)

	String FactionName = CrimeFaction.GetName()
	bNudityIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "NudityIsACrime")
	iNudityBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, FactionName + "NudityBounty", 0, 1000)
	bNudityThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "NudityThaneImmunity")
	bNudityToleratedAtNight = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "NudityToleratedAtNight")
	bNudityInverted = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "NudityInverted")
	fNudityTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, FactionName + "NudityTimeBetweenReports", 0.5, 24.0, 0.5)
	
	bCumIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "CumIsACrime")
	iCumBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, FactionName + "CumBounty", 0, 1000)
	bCumThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "CumThaneImmunity")
	bCumToleratedAtNight = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "CumToleratedAtNight")
	fCumTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, FactionName + "CumTimeBetweenReports", 0.5, 24.0, 0.5)

	bCollaredIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "CollaredIsACrime")
	iCollaredBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, FactionName + "CollaredBounty", 0, 1000)
	bCollaredThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "CollaredThaneImmunity")
	bCollaredToleratedAtNight = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "CollaredToleratedAtNight")
	bCollaredInverted = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "CollaredInverted")
	fCollaredTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, FactionName + "CollaredTimeBetweenReports", 0.5, 24.0, 0.5)
	
	bMasturbationIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "MasturbationIsACrime")
	iMasturbationBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, FactionName + "MasturbationBounty", 0, 1000)
	bMasturbationThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "MasturbationThaneImmunity")
	bMasturbationToleratedAtNight = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "MasturbationToleratedAtNight")
	fMasturbationTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, FactionName + "MasturbationTimeBetweenReports", 0.5, 24.0, 0.5)
	
	bSexIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "SexIsACrime")
	iSexBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, FactionName + "SexBounty", 0, 1000)
	bSexThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "SexThaneImmunity")
	bSexToleratedAtNight = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "SexToleratedAtNight")
	fSexModIfForced = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, FactionName + "SexModIfForced", 0.0, 5.0, 0.5)
	fSexModIfHomo = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, FactionName + "SexModIfHomo", 0.0, 5.0, 0.5)
	fSexModIfBeast = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, FactionName + "SexModIfBeast", 0.0, 5.0, 0.5)
	fSexTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, FactionName + "SexTimeBetweenReports", 0.5, 24.0, 0.5)
	
	bArmedIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "ArmedIsACrime")
	iArmedBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, FactionName + "ArmedBounty", 0, 1000)
	bArmedThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "ArmedThaneImmunity")
	bArmedToleratedAtNight = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "ArmedToleratedAtNight")
	fArmedTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, FactionName + "ArmedTimeBetweenReports", 0.5, 24.0, 0.5)
	bArmedNotDuringCombat = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "ArmedAllowDuringCombat")
	bArmedPossessionIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "ArmedPossessionIsACrime")
	
	bMagicIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "MagicIsACrime")
	iMagicBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, FactionName + "MagicBounty", 0, 1000)
	bMagicThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "MagicThaneImmunity")
	bMagicToleratedAtNight = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "MagicToleratedAtNight")
	fMagicTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, FactionName + "MagicTimeBetweenReports", 0.5, 24.0, 0.5)
	bMagicNotDuringCombat = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "MagicAllowDuringCombat")
	
	bNightIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "NightIsACrime")
	iNightBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, FactionName + "NightBounty", 0, 1000)
	bNightThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, FactionName + "NightThaneImmunity")
	fNightTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, FactionName + "NightTimeBetweenReports", 0.5, 24.0, 0.5)

EndFunction 

Function SavePreset(String FileName)

	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "NudityIsACrime", bNudityIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "NudityBounty", iNudityBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "NudityThaneImmunity", bNudityThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "NudityToleratedAtNight", bNudityToleratedAtNight)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "NudityInverted", bNudityInverted)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "NudityTimeBetweenReports", fNudityTimeBetweenReports)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "CumIsACrime", bCumIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "CumBounty", iCumBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "CumThaneImmunity", bCumThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "CumToleratedAtNight", bCumToleratedAtNight)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "CumTimeBetweenReports", fCumTimeBetweenReports)

	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "CollaredIsACrime", bCollaredIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "CollaredBounty", iCollaredBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "CollaredThaneImmunity", bCollaredThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "CollaredToleratedAtNight", bCollaredToleratedAtNight)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "CollaredInverted", bCollaredInverted)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "CollaredTimeBetweenReports", fCollaredTimeBetweenReports)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "MasturbationIsACrime", bMasturbationIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "MasturbationBounty", iMasturbationBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "MasturbationThaneImmunity", bMasturbationThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "MasturbationToleratedAtNight", bMasturbationToleratedAtNight)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "MasturbationTimeBetweenReports", fMasturbationTimeBetweenReports)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "SexIsACrime", bSexIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "SexBounty", iSexBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "SexThaneImmunity", bSexThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "SexToleratedAtNight", bSexToleratedAtNight)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "SexModIfForced", fSexModIfForced)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "SexModIfHomo", fSexModIfHomo)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "SexModIfBeast", fSexModIfBeast)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "SexTimeBetweenReports", fSexTimeBetweenReports)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "ArmedIsACrime", bArmedIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "ArmedBounty", iArmedBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "ArmedThaneImmunity", bArmedThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "ArmedToleratedAtNight", bArmedToleratedAtNight)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "ArmedTimeBetweenReports", fArmedTimeBetweenReports)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "ArmedAllowDuringCombat", bArmedNotDuringCombat)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "ArmedPossessionIsACrime", bArmedPossessionIsACrime)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "MagicIsACrime", bMagicIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "MagicBounty", iMagicBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "MagicThaneImmunity", bMagicThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "MagicToleratedAtNight", bMagicToleratedAtNight)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "MagicTimeBetweenReports", fMagicTimeBetweenReports)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "MagicAllowDuringCombat", bMagicNotDuringCombat)
	
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "NightIsACrime", bNightIsACrime)
	SLAdventures_MCM_StorageScript.StoreIntValue(FileName, "NightBounty", iNightBounty)
	SLAdventures_MCM_StorageScript.StoreBoolValue(FileName, "NightThaneImmunity", bNightThaneImmunity)
	SLAdventures_MCM_StorageScript.StoreFloatValue(FileName, "NightTimeBetweenReports", fNightTimeBetweenReports)
	
	SLAdventures_MCM_StorageScript.SaveFile(FileName)

EndFunction 

Function LoadPreset(String FileName)

	bNudityIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "NudityIsACrime")
	iNudityBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "NudityBounty", 0, 1000)
	bNudityThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "NudityThaneImmunity")
	bNudityToleratedAtNight = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "NudityToleratedAtNight")
	bNudityInverted = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "NudityInverted")
	fNudityTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "NudityTimeBetweenReports", 0.5, 24.0, 0.5)
	
	bCumIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "CumIsACrime")
	iCumBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "CumBounty", 0, 1000)
	bCumThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "CumThaneImmunity")
	bCumToleratedAtNight = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "CumToleratedAtNight")
	fCumTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "CumTimeBetweenReports", 0.5, 24.0, 0.5)

	bCollaredIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "CollaredIsACrime")
	iCollaredBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "CollaredBounty", 0, 1000)
	bCollaredThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "CollaredThaneImmunity")
	bCollaredToleratedAtNight = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "CollaredToleratedAtNight")
	bCollaredInverted = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "CollaredInverted")
	fCollaredTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "CollaredTimeBetweenReports", 0.5, 24.0, 0.5)
	
	bMasturbationIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "MasturbationIsACrime")
	iMasturbationBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "MasturbationBounty", 0, 1000)
	bMasturbationThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "MasturbationThaneImmunity")
	bMasturbationToleratedAtNight = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "MasturbationToleratedAtNight")
	fMasturbationTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "MasturbationTimeBetweenReports", 0.5, 24.0, 0.5)
	
	bSexIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "SexIsACrime")
	iSexBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "SexBounty", 0, 1000)
	bSexThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "SexThaneImmunity")
	bSexToleratedAtNight = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "SexToleratedAtNight")
	fSexModIfForced = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "SexModIfForced", 0.0, 5.0, 0.5)
	fSexModIfHomo = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "SexModIfHomo", 0.0, 5.0, 0.5)
	fSexModIfBeast = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "SexModIfBeast", 0.0, 5.0, 0.5)
	fSexTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "SexTimeBetweenReports", 0.5, 24.0, 0.5)
	
	bArmedIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "ArmedIsACrime")
	iArmedBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "ArmedBounty", 0, 1000)
	bArmedThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "ArmedThaneImmunity")
	bArmedToleratedAtNight = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "ArmedToleratedAtNight")
	fArmedTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "ArmedTimeBetweenReports", 0.5, 24.0, 0.5)
	bArmedNotDuringCombat = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "ArmedAllowDuringCombat")
	bArmedPossessionIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "ArmedPossessionIsACrime")
	
	bMagicIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "MagicIsACrime")
	iMagicBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "MagicBounty", 0, 1000)
	bMagicThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "MagicThaneImmunity")
	bMagicToleratedAtNight = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "MagicToleratedAtNight")
	fMagicTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "MagicTimeBetweenReports", 0.5, 24.0, 0.5)
	bMagicNotDuringCombat = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "MagicAllowDuringCombat")
	
	bNightIsACrime = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "NightIsACrime")
	iNightBounty = SLAdventures_MCM_StorageScript.LoadIntValue(FileName, "NightBounty", 0, 1000)
	bNightThaneImmunity = SLAdventures_MCM_StorageScript.LoadBoolValue(FileName, "NightThaneImmunity")
	fNightTimeBetweenReports = SLAdventures_MCM_StorageScript.LoadFloatValue(FileName, "NightTimeBetweenReports", 0.5, 24.0, 0.5)

EndFunction

;Variables and Properties - no functions after this line

;Properties
Actor Property Player Auto  

;Nudity
Bool Property bNudityIsACrime = False Auto Hidden 
Int Property iNudityBounty = 0 Auto Hidden 
Bool Property bNudityThaneImmunity = False Auto Hidden 
Bool Property bNudityToleratedAtNight = False Auto Hidden 
Bool Property bNudityInverted = False Auto Hidden 
Float Property fNudityTimeBetweenReports = 0.5 Auto Hidden 

;Cum 
Bool Property bCumIsACrime = False Auto Hidden 
Int Property iCumBounty = 0 Auto Hidden 
Bool Property bCumThaneImmunity = False Auto Hidden 
Bool Property bCumToleratedAtNight = False Auto Hidden 
Float Property fCumTimeBetweenReports = 0.5 Auto Hidden 

;Collared 
Bool Property bCollaredIsACrime = False Auto Hidden 
Int Property iCollaredBounty = 0 Auto Hidden 
Bool Property bCollaredThaneImmunity = False Auto Hidden 
Bool Property bCollaredToleratedAtNight = False Auto Hidden 
Bool Property bCollaredInverted = False Auto Hidden 
Float Property fCollaredTimeBetweenReports = 0.5 Auto Hidden 

;Masturbation 
Bool Property bMasturbationIsACrime = False Auto Hidden 
Int Property iMasturbationBounty = 0 Auto Hidden 
Bool Property bMasturbationThaneImmunity = False Auto Hidden 
Bool Property bMasturbationToleratedAtNight = False Auto Hidden 
Float Property fMasturbationTimeBetweenReports = 0.5 Auto Hidden 

;Sex 
Bool Property bSexIsACrime = False Auto Hidden 
Int Property iSexBounty = 0 Auto Hidden 
Bool Property bSexThaneImmunity = False Auto Hidden 
Bool Property bSexToleratedAtNight = False Auto Hidden 
Float Property fSexModIfForced = 1.0 Auto Hidden 
Float Property fSexModIfHomo = 1.0 Auto Hidden 
Float Property fSexModIfBeast = 1.0 Auto Hidden 
Float Property fSexTimeBetweenReports = 0.5 Auto Hidden 

;Armed 
Bool Property bArmedIsACrime = False Auto Hidden 
Int Property iArmedBounty = 0 Auto Hidden 
Bool Property bArmedThaneImmunity = False Auto Hidden 
Bool Property bArmedToleratedAtNight = False Auto Hidden 
Float Property fArmedTimeBetweenReports = 0.5 Auto Hidden 
Bool Property bArmedNotDuringCombat = False Auto Hidden 
Bool Property bArmedPossessionIsACrime = False Auto Hidden 

;Use Of Magic 
Bool Property bMagicIsACrime = False Auto Hidden 
Int Property iMagicBounty = 0 Auto Hidden 
Bool Property bMagicThaneImmunity = False Auto Hidden 
Bool Property bMagicToleratedAtNight = False Auto Hidden 
Float Property fMagicTimeBetweenReports = 0.5 Auto Hidden 
Bool Property bMagicNotDuringCombat = False Auto Hidden 

;Outside At Night 
Bool Property bNightIsACrime = False Auto Hidden 
Int Property iNightBounty = 0 Auto Hidden 
Bool Property bNightThaneImmunity = False Auto Hidden 
Float Property fNightTimeBetweenReports = 0.5 Auto Hidden 
Float Property fLateNightBegin = 22.0 Auto Hidden 
Float Property fLateNightEnd = 3.0 Auto Hidden 

Faction Property CrimeFaction Auto 
SexlabFramework Property Sexlab Auto 
SLAdventures_Utility Property SLA_Utility Auto 
SLAdventures_RapeScript Property Rape Auto 
SLAdventures_PlayerSexTracker Property PlayerSexTracker Auto 
SLAdventures_SexDiary Property Statistics Auto

;Current Crimes
Int Property iCurrentBounty Auto Hidden 
Float Property fLastNudityReport Auto Hidden 
Float Property fLastCumReport Auto Hidden 
Float Property fLastCollaredReport Auto Hidden 
Float Property fLastMasturbationReport Auto Hidden 
Float Property fLastSexReport Auto Hidden 
Float Property fLastArmedReport Auto Hidden 
Float Property fLastUseOfMagicReport Auto Hidden 
Float Property fLastOutsideAtNightReport Auto Hidden 

;Read-Only Properties 
Int Property CRIME_NUDE_IN_PUBLIC = 10 AutoReadOnly
Int Property CRIME_NOT_NUDE = 11 AutoReadOnly
Int Property CRIME_COVERED_IN_CUM = 20 AutoReadOnly 
Int Property CRIME_MASTURBATING = 30 AutoReadOnly 
Int Property CRIME_SEX = 40 AutoReadOnly 
Int Property CRIME_HOMO = 50 AutoReadOnly 
Int Property CRIME_BEAST = 60 AutoReadOnly 
Int Property CRIME_ARMED = 70 AutoReadOnly 
Int Property CRIME_HAS_WEAPONS = 71 AutoReadOnly 
Int Property CRIME_ARMED_DURING_COMBAT = 72 AutoReadOnly 
Int Property CRIME_HAS_WEAPONS_DURING_COMBAT = 73 AutoReadOnly 
Int Property CRIME_OUT_AT_NIGHT = 80 AutoReadOnly 
Int Property CRIME_COLLARED = 90 AutoReadOnly 
Int Property CRIME_NOT_COLLARED = 91 AutoReadOnly 
Int Property CRIME_USED_MAGIC = 100 AutoReadOnly 

