Scriptname SLAdventures_PlayerNakedScanner extends ReferenceAlias
;This small script determines whether the player is naked under the Crime NakedRule.
;The nudity status is stored in a global variable.
;SexCrime itself asks this rule directly and does not need this script.

SLAdventures_CrimeScript Property Crime Auto 
SLAdventures_MCM_Script Property MCM Auto 
GlobalVariable Property SLAdventures_PlayerIsNaked Auto 

Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	;Debug.Notification("NakedScanner.OnObjectEquipped()")
	If (Crime.IsNaked(MCM.iNakedRule) == True)
		SLAdventures_PlayerIsNaked.SetValue(1)
	Else
		SLAdventures_PlayerIsNaked.SetValue(0)
	EndIf
EndEvent

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	;Debug.Notification("NakedScanner.OnObjectUnEquipped()")
	If (Crime.IsNaked(MCM.iNakedRule) == True)
		SLAdventures_PlayerIsNaked.SetValue(1)
	Else
		SLAdventures_PlayerIsNaked.SetValue(0)
	EndIf
	If ((akBaseObject.HasKeyword(ArmorCuirass) == True) || (akBaseObject.HasKeyword(ClothingBody) == True)) && (ProximityRape.bProximityRapeWhenUndressing == True) 
		ProximityRape.TryRape(TreatAsNaked = True)
	EndIf
EndEvent 

Keyword Property ArmorCuirass Auto 
Keyword Property ClothingBody Auto 
SLAdventures_ProximityRapeScript Property ProximityRape Auto 

;Deprecated

;0.70
SLAdventures_SexCrime Property SC Auto 