Scriptname SLAdventures_PlayerSexTracker extends SLAdventures_SexTracker 

;Events

Event SexlabSceneStart(Form ActorRef, Int tid)

	Actor Tracked = ActorRef as Actor
	sslThreadController Thread = SexLab.GetController(tid) 
	sslBaseAnimation Animation = Thread.Animation
	Actor[] actorList = Thread.Positions		
	Int NumActors = actorList.Length			
	
	bIsInOralScene = Animation.IsOral
	bIsInVaginalScene = Animation.IsVaginal
	bIsInAnalScene = Animation.IsAnal
	bIsUsingBed = Thread.UsingBed
	
	bIsVictim = SexLab.IsVictim(tid, Tracked)
	
	Int index = 0
	While (index < NumActors)
		If (actorList[index] != Tracked)
			actorList[index].AddToFaction(SLAdventures_CurrentPartnersFaction)
		EndIf
	index += 1
	EndWhile 
	
	;Gender of tracked Actor and partners
	Int TrackedGender = Sexlab.GetGender(Player)
		
	Int NumBeasts = Sexlab.CreatureCount(actorList) 
	Int NumMale = Sexlab.MaleCount(actorList) 
	Int NumFemale = Sexlab.FemaleCount(actorList) 
		
	If (TrackedGender == 1)							;Player is female
		NumFemale = NumFemale - 1
	Else											;Player is male
		NumMale = NumMale - 1
	EndIf
		
	If (NumActors == 1)
		iHasSex = 2							;is masturbating
	ElseIf (NumBeasts >= 1)
		iHasSex = 5							;does the beast
	ElseIf (TrackedGender == 1) && (NumFemale >= 1)
		iHasSex = 4							;lesbian
	ElseIf (TrackedGender == 0) && (NumMale >= 1)
		iHasSex = 4							;gay ;known issue: Male tracked actors are counted as gay in "2 males on 1 female"-animations and the like.
	Else 
		iHasSex = 3							;straight
	EndIf 
		
	If (iHasSex == 2)
		SLAdventures_MasturbateRestoreHealth.SetNthEffectMagnitude(0, fMasturbateRestoreHealthMagnitude)
		SLAdventures_MasturbateRestoreMagicka.SetNthEffectMagnitude(0, fMasturbateRestoreMagickaMagnitude)
		SLAdventures_MasturbateRestoreStamina.SetNthEffectMagnitude(0, fMasturbateRestoreStaminaMagnitude)
		Tracked.AddSpell(SLAdventures_MasturbateRestoreHealth, False)
		Tracked.AddSpell(SLAdventures_MasturbateRestoreMagicka, False)
		Tracked.AddSpell(SLAdventures_MasturbateRestoreStamina, False)
	EndIf 
	
EndEvent 

Event SexlabSceneEnd(Form ActorRef, Int tid)

	sslThreadController Thread = SexLab.GetController(tid) 
	sslBaseAnimation Animation = Thread.Animation	
	Actor[] actorList = Thread.Positions
	Int NumActors = actorList.Length				
	
	bIsInOralScene = False
	bIsInVaginalScene = False
	bIsInAnalScene = False
	bIsUsingBed = False
	
	If (iHasSex == 5)
		SexDia.IncrementStatCreatureSex(actorList)
	EndIf
		
	If (iHasSex == 2)
		Player.RemoveSpell(SLAdventures_MasturbateRestoreHealth)
		Player.RemoveSpell(SLAdventures_MasturbateRestoreMagicka)
		Player.RemoveSpell(SLAdventures_MasturbateRestoreStamina)
	EndIf
	
	bIsVictim = False
	iHasSex = 0

	;Remove partners from partner faction
	Int index = 0
	While (index < NumActors)
		If (actorList[index] != Player)
			actorList[index].RemoveFromFaction(SLAdventures_CurrentPartnersFaction)
			If (ActorList[index].IsInFaction(SLAdventures_SexPartnersFaction) == False)
				ActorList[index].AddToFaction(SLAdventures_SexPartnersFaction)
			EndIf
		EndIf
		index += 1
	EndWhile
	
	If (bIsInGangRape == True) 
		RapeController.HandleEndOfSexScene(Self, actorList, Animation.IsOral, Animation.IsVaginal, Animation.IsAnal)
	EndIf
	
	;Give the player some time to redress before being reportable for nudity 
	fAfterSex = 10.0
	RegisterForSingleUpdate(10.0)
	
EndEvent 

Event OnUpdate()
	fAfterSex = 0.0
EndEvent

;Functions

Function RegisterSexlab()
	RegisterForModEvent("PlayerTrack_Start", "SexlabSceneStart")
	RegisterForModEvent("PlayerTrack_End", "SexlabSceneEnd")
EndFunction

Float Property fAfterSex = 0.0 Auto Hidden 
Float Property fMasturbateRestoreHealthMagnitude Auto Hidden 
Float Property fMasturbateRestoreMagickaMagnitude Auto Hidden 
Float Property fMasturbateRestoreStaminaMagnitude Auto Hidden 
SLAdventures_SexDiary Property SexDia Auto
SLAdventures_RapeScript Property Rape Auto 
Faction Property SLAdventures_CurrentPartnersFaction Auto
Faction Property SLAdventures_SexPartnersFaction Auto  
Spell Property SLAdventures_MasturbateRestoreHealth Auto 
Spell Property SLAdventures_MasturbateRestoreMagicka Auto 
Spell Property SLAdventures_MasturbateRestoreStamina Auto 
