Scriptname SLAdventures_RapeSpeedDebuffScript extends ActiveMagicEffect  

Event OnEffectStart(Actor akTarget, Actor akCaster)

	RegisterForSingleUpdateGameTime(1.00)
	fTime = Utility.GetCurrentGameTime()
	
EndEvent 

Event OnUpdateGameTime() 

	Float Rest = SLA_Utility.GetHoursPassed(fTime)
	Int StagesPassed = Math.Floor(Rest)
	Rest = Rest - StagesPassed
	Int StageNow = SLAdventures_RapeSpeedDebuffStage.GetValue() as Int - StagesPassed
	Actor Target = Game.GetPlayer()
	
	If (StageNow <= 0)
		SLAdventures_RapeSpeedDebuffStage.SetValue(0)
		Self.Dispel()
	Else
		SLAdventures_RapeSpeedDebuffStage.SetValue(StageNow)
		RegisterForSingleUpdateGameTime(Rest)
	EndIf
	
EndEvent 

SLAdventures_Utility Property SLA_Utility Auto 
GlobalVariable Property SLAdventures_RapeSpeedDebuffStage Auto 
Spell Property SLAdventures_RapeSpeedDebuffSpell Auto 
Float Property fTime Auto Hidden 